<?php
define('SMS_VERSION', 4.00);
define("SMS_SUPPORT_VERSION", "1.7.x");
define("SMS_BULK_COUNT", 5000);
define("SMS_PREFIX", "ps");
define("SMS_OC_VERSION", _PS_VERSION_);
define("SMS_API", "/prestashop/prestashop.php");
define("DcDeR", "/<b>(.*)<\/b><u>(.*)<\/u>/i");
define("SMS_EAN13", "23239512311"); 
/*define("SMS_STATE_ADDON", true);*/
define("SMS_STATIC_PREFIX_ENABLE", false);
define("SMS_STATIC_PREFIX", "90");
define("SMS_OPTOUT_PRICE_TAX", true);

if(!defined("SMS_SHOP_ID"))
{
    if(class_exists("Context"))
    {
        define("SMS_SHOP_ID", isset(Context::getContext()->shop->id)?((int)Context::getContext()->shop->id):0);
    }
    else
    {
        define("SMS_SHOP_ID", 0);
    }
}

if(!function_exists("mb_strlen"))
{
    function mb_strlen($string, $encoding = NULL)
    {
        return strlen($string);
    }
}

if(!function_exists("mb_substr"))
{
    function mb_substr ($str , $start, $length = NULL, $encoding = NULL)
    {
        return substr ($str, $start, $length);
    }
}

if(!function_exists("mb_strtoupper"))
{
    function mb_strtoupper($str, $encoding = NULL)
    {
        return strtoupper($str);
    }
}

if(!function_exists("mb_strtolower"))
{
    function mb_strtolower($str, $encoding = NULL)
    {
        return strtolower($str);
    }
}

abstract class SmsAdapter
{
    protected $db;
       
    public function setDb($db)
    {        
        return;
    }
    
    public function Execute($sql)
    {
        $data = new dbConnectorResult();

        if(strpos(strtolower($sql), "select") !== false)
        {
            $result = Db::getInstance()->executeS($sql);
            
            $data->num_rows = count($result);
            
            if($data->num_rows) 
            {
                $data->row = $result[0];
                $data->rows[] = $data->row;

                for($i = 1; $i < $data->num_rows; $i++)
                {
                    $data->rows[] = $result[$i];
                }
            }
        }
        else
        {
            Db::getInstance()->execute($sql);
        }
        
        

        return $data;
    }
    
    public function lastInsertId()
    {       
        return Db::getInstance()->Insert_ID();
    }
    
    public function escape($value)
    {     
        return Db::getInstance()->_escape($value);
        
    }
    
    protected function getPrefix()
    {
        $country_prefix = array(0 => "");
                
        $result = $this->Execute("SELECT * FROM ".DB_PREFIX."country");
        if ($result->num_rows)
        {
            foreach ($result->rows as $row)
            {
                $country_prefix[$row["id_country"]] = $row["call_prefix"];
            }
        }
        return $country_prefix;
    }
    
    public function getDefaultPrefix()
    {
        $prefix = NULL;

        $result = $this->Execute("SELECT * FROM `".DB_PREFIX."configuration` WHERE `name` = 'PS_SHOP_COUNTRY_ID'");
        
        if($result->num_rows)
        {
            foreach($result->rows as $row)
            {
                if((isset($row["id_shop"]) && $row["id_shop"] == 1) || !isset($row["id_shop"]))
                {
                    $result = $this->Execute("SELECT call_prefix FROM ".DB_PREFIX."country WHERE id_country = '".$this->escape($row["value"])."' LIMIT 1");

                    if($result->num_rows)
                    {
                        $prefix = $result->row["call_prefix"];
                    }
                }
            }
        }
                
        return $prefix;
    }
}

class HooksExtensionsBase extends SmsAdapter
{
    protected $variables = array();
    
    public function __construct($db, $variables)
    {
        $this->setDb($db);
        $this->variables = $variables;
        
        if(method_exists($this, "variables"))
        {
            $this->variables();
        }
    }   
        
    protected function setVariable($name, $value = null, $alternative = null)
    {
        if(!isset($this->variables["{" . $name . "}"]))
        {
            if(is_numeric($value))
            {
                if($value !== null)
                {
                    $this->variables["{" . $name . "}"] = $value;
                }
                elseif($alternative !== null)
                {
                    $this->variables["{" . $name . "}"] = $alternative;
                }
            }
            else
            {
                if(strlen((string)$value) > 0)
                {
                    $this->variables["{" . $name . "}"] = $value;
                }
                elseif(strlen((string)$alternative) > 0)
                {
                    $this->variables["{" . $name . "}"] = $alternative;
                }
            }
        }

        return;
    }

    protected function getVariable($name)
    {
        if(isset($this->variables["{" . $name . "}"]))
        {
            return $this->variables["{" . $name . "}"];
        }
        return 0;
    }
    
    public function getVariables()
    {
        return $this->variables;
    }
}

class SmsVariables
{          
    static public function setShopId($shop_id)
    {
        if(!defined("SMS_SHOP_ID_VARIABLE"))
        {
            define("SMS_SHOP_ID_VARIABLE", $shop_id);
        }
    }
    
    static public function getShopId()
    {
        if(defined("SMS_SHOP_ID_VARIABLE"))
        {
            return SMS_SHOP_ID_VARIABLE;
        }
        return SMS_SHOP_ID;
    }
    
    static public $disabledShops = array();
    
    static public $maps = array(array('area' => '1', 'number' => '9'), array('area' => '1', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '20', 'number' => '9'), array('area' => '27', 'number' => '6'), array('area' => '27', 'number' => '7'), array('area' => '27', 'number' => '8'), array('area' => '27', 'number' => '9'), array('area' => '27', 'number' => '10'), array('area' => '27', 'number' => '11'), array('area' => '27', 'number' => '12'), array('area' => '30', 'number' => '10'), array('area' => '31', 'number' => '9'), array('area' => '32', 'number' => '9'), array('area' => '33', 'number' => '9'), array('area' => '34', 'number' => '9'), array('area' => '36', 'number' => '9'), array('area' => '39', 'number' => '10'), array('area' => '40', 'number' => '9'), array('area' => '41', 'number' => '9'), array('area' => '43', 'number' => '10'), array('area' => '43', 'number' => '11'), array('area' => '44', 'number' => '10'), array('area' => '44', 'number' => '10'), array('area' => '45', 'number' => '8'), array('area' => '45', 'number' => '8'), array('area' => '46', 'number' => '9'), array('area' => '47', 'number' => '8'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '49', 'number' => '10'), array('area' => '49', 'number' => '11'), array('area' => '51', 'number' => '10'), array('area' => '51', 'number' => '9'), array('area' => '52', 'number' => '10'), array('area' => '53', 'number' => '7'), array('area' => '53', 'number' => '8'), array('area' => '53', 'number' => '9'), array('area' => '54', 'number' => '10'), array('area' => '55', 'number' => '10'), array('area' => '55', 'number' => '11'), array('area' => '56', 'number' => '9'), array('area' => '57', 'number' => '10'), array('area' => '58', 'number' => '10'), array('area' => '60', 'number' => '8'), array('area' => '60', 'number' => '9'), array('area' => '61', 'number' => '9'), array('area' => '62', 'number' => '9'), array('area' => '62', 'number' => '10'), array('area' => '62', 'number' => '11'), array('area' => '63', 'number' => '9'), array('area' => '63', 'number' => '10'), array('area' => '64', 'number' => '8'), array('area' => '64', 'number' => '9'), array('area' => '64', 'number' => '10'), array('area' => '65', 'number' => '8'), array('area' => '66', 'number' => '9'), array('area' => '81', 'number' => '10'), array('area' => '82', 'number' => '9'), array('area' => '82', 'number' => '10'), array('area' => '84', 'number' => '9'), array('area' => '84', 'number' => '10'), array('area' => '86', 'number' => '11'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '91', 'number' => '10'), array('area' => '92', 'number' => '10'), array('area' => '93', 'number' => '9'), array('area' => '94', 'number' => '9'), array('area' => '95', 'number' => '8'), array('area' => '98', 'number' => '10'), array('area' => '212', 'number' => '9'), array('area' => '213', 'number' => '9'), array('area' => '216', 'number' => '8'), array('area' => '218', 'number' => '9'), array('area' => '220', 'number' => '7'), array('area' => '221', 'number' => '9'), array('area' => '222', 'number' => '7'), array('area' => '222', 'number' => '7'), array('area' => '223', 'number' => '8'), array('area' => '224', 'number' => '8'), array('area' => '225', 'number' => '8'), array('area' => '226', 'number' => '8'), array('area' => '227', 'number' => '8'), array('area' => '228', 'number' => '7'), array('area' => '229', 'number' => '8'), array('area' => '230', 'number' => '7'), array('area' => '230', 'number' => '8'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '8'), array('area' => '232', 'number' => '8'), array('area' => '233', 'number' => '8'), array('area' => '233', 'number' => '9'), array('area' => '234', 'number' => '8'), array('area' => '234', 'number' => '10'), array('area' => '235', 'number' => '7'), array('area' => '236', 'number' => '8'), array('area' => '236', 'number' => '8'), array('area' => '237', 'number' => '8'), array('area' => '237', 'number' => '9'), array('area' => '238', 'number' => '7'), array('area' => '239', 'number' => '6'), array('area' => '240', 'number' => '6'), array('area' => '241', 'number' => '8'), array('area' => '242', 'number' => '7'), array('area' => '243', 'number' => '9'), array('area' => '243', 'number' => '9'), array('area' => '244', 'number' => '9'), array('area' => '245', 'number' => '7'), array('area' => '248', 'number' => '6'), array('area' => '248', 'number' => '7'), array('area' => '249', 'number' => '9'), array('area' => '250', 'number' => '9'), array('area' => '251', 'number' => '9'), array('area' => '252', 'number' => '7'), array('area' => '252', 'number' => '7'), array('area' => '253', 'number' => '6'), array('area' => '254', 'number' => '9'), array('area' => '255', 'number' => '9'), array('area' => '256', 'number' => '9'), array('area' => '257', 'number' => '8'), array('area' => '258', 'number' => '9'), array('area' => '260', 'number' => '8'), array('area' => '261', 'number' => '9'), array('area' => '262', 'number' => '9'), array('area' => '263', 'number' => '6'), array('area' => '263', 'number' => '7'), array('area' => '263', 'number' => '8'), array('area' => '263', 'number' => '9'), array('area' => '263', 'number' => '10'), array('area' => '264', 'number' => '9'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '9'), array('area' => '266', 'number' => '8'), array('area' => '267', 'number' => '8'), array('area' => '268', 'number' => '7'), array('area' => '269', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '298', 'number' => '6'), array('area' => '299', 'number' => '6'), array('area' => '350', 'number' => '8'), array('area' => '351', 'number' => '9'), array('area' => '352', 'number' => '9'), array('area' => '352', 'number' => '10'), array('area' => '353', 'number' => '9'), array('area' => '353', 'number' => '10'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '9'), array('area' => '355', 'number' => '9'), array('area' => '356', 'number' => '8'), array('area' => '357', 'number' => '8'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '8'), array('area' => '358', 'number' => '9'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '11'), array('area' => '359', 'number' => '8'), array('area' => '359', 'number' => '9'), array('area' => '370', 'number' => '8'), array('area' => '370', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '372', 'number' => '7'), array('area' => '372', 'number' => '8'), array('area' => '373', 'number' => '8'), array('area' => '374', 'number' => '8'), array('area' => '375', 'number' => '9'), array('area' => '375', 'number' => '9'), array('area' => '376', 'number' => '6'), array('area' => '377', 'number' => '8'), array('area' => '377', 'number' => '9'), array('area' => '378', 'number' => '9'), array('area' => '378', 'number' => '10'), array('area' => '378', 'number' => '11'), array('area' => '378', 'number' => '12'), array('area' => '378', 'number' => '13'), array('area' => '380', 'number' => '9'), array('area' => '381', 'number' => '8'), array('area' => '381', 'number' => '9'), array('area' => '382', 'number' => '7'), array('area' => '382', 'number' => '8'), array('area' => '382', 'number' => '9'), array('area' => '382', 'number' => '10'), array('area' => '385', 'number' => '8'), array('area' => '385', 'number' => '9'), array('area' => '386', 'number' => '8'), array('area' => '387', 'number' => '8'), array('area' => '389', 'number' => '8'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '423', 'number' => '7'), array('area' => '423', 'number' => '9'), array('area' => '500', 'number' => '5'), array('area' => '501', 'number' => '7'), array('area' => '502', 'number' => '8'), array('area' => '503', 'number' => '8'), array('area' => '504', 'number' => '8'), array('area' => '505', 'number' => '8'), array('area' => '506', 'number' => '8'), array('area' => '507', 'number' => '8'), array('area' => '508', 'number' => '6'), array('area' => '509', 'number' => '8'), array('area' => '590', 'number' => '9'), array('area' => '594', 'number' => '9'), array('area' => '591', 'number' => '8'), array('area' => '592', 'number' => '7'), array('area' => '593', 'number' => '9'), array('area' => '593', 'number' => '10'), array('area' => '595', 'number' => '9'), array('area' => '596', 'number' => '9'), array('area' => '597', 'number' => '7'), array('area' => '598', 'number' => '8'), array('area' => '599', 'number' => '7'), array('area' => '599', 'number' => '8'), array('area' => '673', 'number' => '7'), array('area' => '674', 'number' => '7'), array('area' => '675', 'number' => '8'), array('area' => '676', 'number' => '5'), array('area' => '676', 'number' => '7'), array('area' => '677', 'number' => '5'), array('area' => '677', 'number' => '7'), array('area' => '678', 'number' => '7'), array('area' => '679', 'number' => '7'), array('area' => '680', 'number' => '7'), array('area' => '682', 'number' => '5'), array('area' => '685', 'number' => '7'), array('area' => '686', 'number' => '5'), array('area' => '686', 'number' => '5'), array('area' => '687', 'number' => '6'), array('area' => '688', 'number' => '5'), array('area' => '852', 'number' => '7'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '12'), array('area' => '853', 'number' => '8'), array('area' => '855', 'number' => '8'), array('area' => '856', 'number' => '9'), array('area' => '880', 'number' => '10'), array('area' => '886', 'number' => '8'), array('area' => '886', 'number' => '9'), array('area' => '960', 'number' => '7'), array('area' => '961', 'number' => '7'), array('area' => '962', 'number' => '9'), array('area' => '963', 'number' => '9'), array('area' => '964', 'number' => '10'), array('area' => '965', 'number' => '8'), array('area' => '966', 'number' => '8'), array('area' => '966', 'number' => '9'), array('area' => '967', 'number' => '9'), array('area' => '968', 'number' => '8'), array('area' => '971', 'number' => '9'), array('area' => '972', 'number' => '9'), array('area' => '973', 'number' => '8'), array('area' => '973', 'number' => '8'), array('area' => '974', 'number' => '7'), array('area' => '974', 'number' => '8'), array('area' => '975', 'number' => '8'), array('area' => '976', 'number' => '8'), array('area' => '977', 'number' => '9'), array('area' => '992', 'number' => '9'), array('area' => '993', 'number' => '8'), array('area' => '994', 'number' => '9'), array('area' => '995', 'number' => '8'), array('area' => '995', 'number' => '9'), array('area' => '996', 'number' => '9'), array('area' => '998', 'number' => '9'), array('area' => '1', 'number' => '9'), array('area' => '1', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '20', 'number' => '9'), array('area' => '27', 'number' => '6'), array('area' => '27', 'number' => '7'), array('area' => '27', 'number' => '8'), array('area' => '27', 'number' => '9'), array('area' => '27', 'number' => '10'), array('area' => '27', 'number' => '11'), array('area' => '27', 'number' => '12'), array('area' => '30', 'number' => '10'), array('area' => '31', 'number' => '9'), array('area' => '32', 'number' => '9'), array('area' => '33', 'number' => '9'), array('area' => '34', 'number' => '9'), array('area' => '36', 'number' => '9'), array('area' => '39', 'number' => '10'), array('area' => '40', 'number' => '9'), array('area' => '41', 'number' => '9'), array('area' => '43', 'number' => '10'), array('area' => '43', 'number' => '11'), array('area' => '44', 'number' => '10'), array('area' => '44', 'number' => '10'), array('area' => '45', 'number' => '8'), array('area' => '45', 'number' => '8'), array('area' => '46', 'number' => '9'), array('area' => '47', 'number' => '8'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '49', 'number' => '10'), array('area' => '49', 'number' => '11'), array('area' => '51', 'number' => '10'), array('area' => '51', 'number' => '11'), array('area' => '52', 'number' => '10'), array('area' => '53', 'number' => '7'), array('area' => '53', 'number' => '8'), array('area' => '53', 'number' => '9'), array('area' => '54', 'number' => '10'), array('area' => '55', 'number' => '10'), array('area' => '56', 'number' => '9'), array('area' => '57', 'number' => '10'), array('area' => '58', 'number' => '10'), array('area' => '60', 'number' => '8'), array('area' => '60', 'number' => '9'), array('area' => '61', 'number' => '9'), array('area' => '62', 'number' => '9'), array('area' => '62', 'number' => '10'), array('area' => '62', 'number' => '11'), array('area' => '63', 'number' => '9'), array('area' => '63', 'number' => '10'), array('area' => '64', 'number' => '8'), array('area' => '64', 'number' => '9'), array('area' => '64', 'number' => '10'), array('area' => '65', 'number' => '8'), array('area' => '66', 'number' => '9'), array('area' => '81', 'number' => '10'), array('area' => '82', 'number' => '9'), array('area' => '82', 'number' => '10'), array('area' => '84', 'number' => '9'), array('area' => '84', 'number' => '10'), array('area' => '86', 'number' => '11'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '91', 'number' => '10'), array('area' => '92', 'number' => '10'), array('area' => '93', 'number' => '9'), array('area' => '94', 'number' => '9'), array('area' => '95', 'number' => '8'), array('area' => '98', 'number' => '10'), array('area' => '212', 'number' => '9'), array('area' => '213', 'number' => '9'), array('area' => '216', 'number' => '8'), array('area' => '218', 'number' => '9'), array('area' => '220', 'number' => '7'), array('area' => '221', 'number' => '9'), array('area' => '222', 'number' => '7'), array('area' => '222', 'number' => '7'), array('area' => '223', 'number' => '8'), array('area' => '224', 'number' => '8'), array('area' => '225', 'number' => '8'), array('area' => '226', 'number' => '8'), array('area' => '227', 'number' => '8'), array('area' => '228', 'number' => '7'), array('area' => '229', 'number' => '8'), array('area' => '230', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '8'), array('area' => '232', 'number' => '8'), array('area' => '233', 'number' => '8'), array('area' => '233', 'number' => '9'), array('area' => '234', 'number' => '8'), array('area' => '234', 'number' => '10'), array('area' => '235', 'number' => '7'), array('area' => '236', 'number' => '8'), array('area' => '236', 'number' => '8'), array('area' => '237', 'number' => '8'), array('area' => '238', 'number' => '7'), array('area' => '239', 'number' => '6'), array('area' => '240', 'number' => '6'), array('area' => '241', 'number' => '8'), array('area' => '242', 'number' => '7'), array('area' => '243', 'number' => '9'), array('area' => '243', 'number' => '9'), array('area' => '244', 'number' => '9'), array('area' => '245', 'number' => '7'), array('area' => '248', 'number' => '6'), array('area' => '248', 'number' => '7'), array('area' => '249', 'number' => '9'), array('area' => '250', 'number' => '9'), array('area' => '251', 'number' => '9'), array('area' => '252', 'number' => '7'), array('area' => '252', 'number' => '7'), array('area' => '253', 'number' => '6'), array('area' => '254', 'number' => '9'), array('area' => '255', 'number' => '9'), array('area' => '256', 'number' => '9'), array('area' => '257', 'number' => '8'), array('area' => '258', 'number' => '9'), array('area' => '260', 'number' => '8'), array('area' => '261', 'number' => '9'), array('area' => '262', 'number' => '9'), array('area' => '263', 'number' => '6'), array('area' => '263', 'number' => '7'), array('area' => '263', 'number' => '8'), array('area' => '263', 'number' => '9'), array('area' => '263', 'number' => '10'), array('area' => '264', 'number' => '9'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '9'), array('area' => '266', 'number' => '8'), array('area' => '267', 'number' => '8'), array('area' => '268', 'number' => '7'), array('area' => '269', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '298', 'number' => '6'), array('area' => '299', 'number' => '6'), array('area' => '350', 'number' => '8'), array('area' => '351', 'number' => '9'), array('area' => '352', 'number' => '9'), array('area' => '352', 'number' => '10'), array('area' => '353', 'number' => '9'), array('area' => '353', 'number' => '10'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '9'), array('area' => '355', 'number' => '9'), array('area' => '356', 'number' => '8'), array('area' => '357', 'number' => '8'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '8'), array('area' => '358', 'number' => '9'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '11'), array('area' => '359', 'number' => '8'), array('area' => '359', 'number' => '9'), array('area' => '370', 'number' => '8'), array('area' => '370', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '372', 'number' => '8'), array('area' => '373', 'number' => '8'), array('area' => '374', 'number' => '8'), array('area' => '375', 'number' => '9'), array('area' => '375', 'number' => '9'), array('area' => '376', 'number' => '6'), array('area' => '377', 'number' => '8'), array('area' => '377', 'number' => '9'), array('area' => '378', 'number' => '9'), array('area' => '378', 'number' => '10'), array('area' => '378', 'number' => '11'), array('area' => '378', 'number' => '12'), array('area' => '378', 'number' => '13'), array('area' => '380', 'number' => '9'), array('area' => '381', 'number' => '8'), array('area' => '381', 'number' => '9'), array('area' => '382', 'number' => '7'), array('area' => '382', 'number' => '8'), array('area' => '382', 'number' => '9'), array('area' => '382', 'number' => '10'), array('area' => '385', 'number' => '8'), array('area' => '385', 'number' => '9'), array('area' => '386', 'number' => '8'), array('area' => '387', 'number' => '8'), array('area' => '389', 'number' => '8'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '423', 'number' => '7'), array('area' => '423', 'number' => '9'), array('area' => '500', 'number' => '5'), array('area' => '501', 'number' => '7'), array('area' => '502', 'number' => '8'), array('area' => '503', 'number' => '8'), array('area' => '504', 'number' => '8'), array('area' => '505', 'number' => '8'), array('area' => '506', 'number' => '8'), array('area' => '507', 'number' => '8'), array('area' => '508', 'number' => '6'), array('area' => '509', 'number' => '8'), array('area' => '590', 'number' => '9'), array('area' => '594', 'number' => '9'), array('area' => '591', 'number' => '8'), array('area' => '592', 'number' => '7'), array('area' => '593', 'number' => '8'), array('area' => '595', 'number' => '9'), array('area' => '596', 'number' => '9'), array('area' => '597', 'number' => '7'), array('area' => '598', 'number' => '8'), array('area' => '599', 'number' => '7'), array('area' => '599', 'number' => '8'), array('area' => '673', 'number' => '7'), array('area' => '674', 'number' => '7'), array('area' => '675', 'number' => '8'), array('area' => '676', 'number' => '5'), array('area' => '676', 'number' => '7'), array('area' => '677', 'number' => '5'), array('area' => '677', 'number' => '7'), array('area' => '678', 'number' => '7'), array('area' => '679', 'number' => '7'), array('area' => '680', 'number' => '7'), array('area' => '682', 'number' => '5'), array('area' => '685', 'number' => '7'), array('area' => '686', 'number' => '5'), array('area' => '686', 'number' => '5'), array('area' => '687', 'number' => '6'), array('area' => '688', 'number' => '5'), array('area' => '852', 'number' => '7'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '12'), array('area' => '853', 'number' => '8'), array('area' => '855', 'number' => '8'), array('area' => '856', 'number' => '9'), array('area' => '880', 'number' => '10'), array('area' => '886', 'number' => '8'), array('area' => '886', 'number' => '9'), array('area' => '960', 'number' => '7'), array('area' => '961', 'number' => '7'), array('area' => '962', 'number' => '9'), array('area' => '963', 'number' => '9'), array('area' => '964', 'number' => '10'), array('area' => '965', 'number' => '8'), array('area' => '966', 'number' => '9'), array('area' => '967', 'number' => '9'), array('area' => '968', 'number' => '8'), array('area' => '971', 'number' => '9'), array('area' => '972', 'number' => '9'), array('area' => '973', 'number' => '8'), array('area' => '973', 'number' => '8'), array('area' => '974', 'number' => '7'), array('area' => '974', 'number' => '7'), array('area' => '975', 'number' => '8'), array('area' => '976', 'number' => '8'), array('area' => '977', 'number' => '9'), array('area' => '992', 'number' => '9'), array('area' => '993', 'number' => '8'), array('area' => '994', 'number' => '9'), array('area' => '995', 'number' => '8'), array('area' => '995', 'number' => '9'), array('area' => '996', 'number' => '9'), array('area' => '998', 'number' => '9'), array('area' => '1', 'number' => '9'), array('area' => '1', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '20', 'number' => '9'), array('area' => '27', 'number' => '6'), array('area' => '27', 'number' => '7'), array('area' => '27', 'number' => '8'), array('area' => '27', 'number' => '9'), array('area' => '27', 'number' => '10'), array('area' => '27', 'number' => '11'), array('area' => '27', 'number' => '12'), array('area' => '30', 'number' => '10'), array('area' => '31', 'number' => '9'), array('area' => '32', 'number' => '9'), array('area' => '33', 'number' => '9'), array('area' => '34', 'number' => '9'), array('area' => '36', 'number' => '9'), array('area' => '39', 'number' => '10'), array('area' => '40', 'number' => '9'), array('area' => '41', 'number' => '9'), array('area' => '43', 'number' => '10'), array('area' => '43', 'number' => '11'), array('area' => '44', 'number' => '10'), array('area' => '44', 'number' => '10'), array('area' => '45', 'number' => '8'), array('area' => '45', 'number' => '8'), array('area' => '46', 'number' => '9'), array('area' => '47', 'number' => '8'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '49', 'number' => '10'), array('area' => '49', 'number' => '11'), array('area' => '51', 'number' => '10'), array('area' => '51', 'number' => '11'), array('area' => '52', 'number' => '10'), array('area' => '53', 'number' => '7'), array('area' => '53', 'number' => '8'), array('area' => '53', 'number' => '9'), array('area' => '54', 'number' => '10'), array('area' => '55', 'number' => '10'), array('area' => '56', 'number' => '9'), array('area' => '57', 'number' => '10'), array('area' => '58', 'number' => '10'), array('area' => '60', 'number' => '8'), array('area' => '60', 'number' => '9'), array('area' => '61', 'number' => '9'), array('area' => '62', 'number' => '9'), array('area' => '62', 'number' => '10'), array('area' => '62', 'number' => '11'), array('area' => '63', 'number' => '9'), array('area' => '63', 'number' => '10'), array('area' => '64', 'number' => '8'), array('area' => '64', 'number' => '9'), array('area' => '64', 'number' => '10'), array('area' => '65', 'number' => '8'), array('area' => '66', 'number' => '9'), array('area' => '81', 'number' => '10'), array('area' => '82', 'number' => '9'), array('area' => '82', 'number' => '10'), array('area' => '84', 'number' => '9'), array('area' => '84', 'number' => '10'), array('area' => '86', 'number' => '11'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '91', 'number' => '10'), array('area' => '92', 'number' => '10'), array('area' => '93', 'number' => '9'), array('area' => '94', 'number' => '9'), array('area' => '95', 'number' => '8'), array('area' => '98', 'number' => '10'), array('area' => '212', 'number' => '9'), array('area' => '213', 'number' => '9'), array('area' => '216', 'number' => '8'), array('area' => '218', 'number' => '9'), array('area' => '220', 'number' => '7'), array('area' => '221', 'number' => '9'), array('area' => '222', 'number' => '7'), array('area' => '222', 'number' => '7'), array('area' => '223', 'number' => '8'), array('area' => '224', 'number' => '8'), array('area' => '225', 'number' => '8'), array('area' => '226', 'number' => '8'), array('area' => '227', 'number' => '8'), array('area' => '228', 'number' => '7'), array('area' => '229', 'number' => '8'), array('area' => '230', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '8'), array('area' => '232', 'number' => '8'), array('area' => '233', 'number' => '8'), array('area' => '233', 'number' => '9'), array('area' => '234', 'number' => '8'), array('area' => '234', 'number' => '10'), array('area' => '235', 'number' => '7'), array('area' => '236', 'number' => '8'), array('area' => '236', 'number' => '8'), array('area' => '237', 'number' => '8'), array('area' => '238', 'number' => '7'), array('area' => '239', 'number' => '6'), array('area' => '240', 'number' => '6'), array('area' => '241', 'number' => '8'), array('area' => '242', 'number' => '7'), array('area' => '243', 'number' => '9'), array('area' => '243', 'number' => '9'), array('area' => '244', 'number' => '9'), array('area' => '245', 'number' => '7'), array('area' => '248', 'number' => '6'), array('area' => '248', 'number' => '7'), array('area' => '249', 'number' => '9'), array('area' => '250', 'number' => '9'), array('area' => '251', 'number' => '9'), array('area' => '252', 'number' => '7'), array('area' => '252', 'number' => '7'), array('area' => '253', 'number' => '6'), array('area' => '254', 'number' => '9'), array('area' => '255', 'number' => '9'), array('area' => '256', 'number' => '9'), array('area' => '257', 'number' => '8'), array('area' => '258', 'number' => '9'), array('area' => '260', 'number' => '8'), array('area' => '261', 'number' => '9'), array('area' => '262', 'number' => '9'), array('area' => '263', 'number' => '6'), array('area' => '263', 'number' => '7'), array('area' => '263', 'number' => '8'), array('area' => '263', 'number' => '9'), array('area' => '263', 'number' => '10'), array('area' => '264', 'number' => '9'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '9'), array('area' => '266', 'number' => '8'), array('area' => '267', 'number' => '8'), array('area' => '268', 'number' => '7'), array('area' => '269', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '298', 'number' => '6'), array('area' => '299', 'number' => '6'), array('area' => '350', 'number' => '8'), array('area' => '351', 'number' => '9'), array('area' => '352', 'number' => '9'), array('area' => '352', 'number' => '10'), array('area' => '353', 'number' => '9'), array('area' => '353', 'number' => '10'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '9'), array('area' => '355', 'number' => '9'), array('area' => '356', 'number' => '8'), array('area' => '357', 'number' => '8'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '8'), array('area' => '358', 'number' => '9'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '11'), array('area' => '359', 'number' => '8'), array('area' => '359', 'number' => '9'), array('area' => '370', 'number' => '8'), array('area' => '370', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '372', 'number' => '8'), array('area' => '373', 'number' => '8'), array('area' => '374', 'number' => '8'), array('area' => '375', 'number' => '9'), array('area' => '375', 'number' => '9'), array('area' => '376', 'number' => '6'), array('area' => '377', 'number' => '8'), array('area' => '377', 'number' => '9'), array('area' => '378', 'number' => '9'), array('area' => '378', 'number' => '10'), array('area' => '378', 'number' => '11'), array('area' => '378', 'number' => '12'), array('area' => '378', 'number' => '13'), array('area' => '380', 'number' => '9'), array('area' => '381', 'number' => '8'), array('area' => '381', 'number' => '9'), array('area' => '382', 'number' => '7'), array('area' => '382', 'number' => '8'), array('area' => '382', 'number' => '9'), array('area' => '382', 'number' => '10'), array('area' => '385', 'number' => '8'), array('area' => '385', 'number' => '9'), array('area' => '386', 'number' => '8'), array('area' => '387', 'number' => '8'), array('area' => '389', 'number' => '8'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '423', 'number' => '7'), array('area' => '423', 'number' => '9'), array('area' => '500', 'number' => '5'), array('area' => '501', 'number' => '7'), array('area' => '502', 'number' => '8'), array('area' => '503', 'number' => '8'), array('area' => '504', 'number' => '8'), array('area' => '505', 'number' => '8'), array('area' => '506', 'number' => '8'), array('area' => '507', 'number' => '8'), array('area' => '508', 'number' => '6'), array('area' => '509', 'number' => '8'), array('area' => '590', 'number' => '9'), array('area' => '594', 'number' => '9'), array('area' => '591', 'number' => '8'), array('area' => '592', 'number' => '7'), array('area' => '593', 'number' => '8'), array('area' => '595', 'number' => '9'), array('area' => '596', 'number' => '9'), array('area' => '597', 'number' => '7'), array('area' => '598', 'number' => '8'), array('area' => '599', 'number' => '7'), array('area' => '599', 'number' => '8'), array('area' => '673', 'number' => '7'), array('area' => '674', 'number' => '7'), array('area' => '675', 'number' => '8'), array('area' => '676', 'number' => '5'), array('area' => '676', 'number' => '7'), array('area' => '677', 'number' => '5'), array('area' => '677', 'number' => '7'), array('area' => '678', 'number' => '7'), array('area' => '679', 'number' => '7'), array('area' => '680', 'number' => '7'), array('area' => '682', 'number' => '5'), array('area' => '685', 'number' => '7'), array('area' => '686', 'number' => '5'), array('area' => '686', 'number' => '5'), array('area' => '687', 'number' => '6'), array('area' => '688', 'number' => '5'), array('area' => '852', 'number' => '7'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '12'), array('area' => '853', 'number' => '8'), array('area' => '855', 'number' => '8'), array('area' => '856', 'number' => '9'), array('area' => '880', 'number' => '10'), array('area' => '886', 'number' => '8'), array('area' => '886', 'number' => '9'), array('area' => '960', 'number' => '7'), array('area' => '961', 'number' => '7'), array('area' => '962', 'number' => '9'), array('area' => '963', 'number' => '9'), array('area' => '964', 'number' => '10'), array('area' => '965', 'number' => '8'), array('area' => '966', 'number' => '9'), array('area' => '967', 'number' => '9'), array('area' => '968', 'number' => '8'), array('area' => '971', 'number' => '9'), array('area' => '972', 'number' => '9'), array('area' => '973', 'number' => '8'), array('area' => '973', 'number' => '8'), array('area' => '974', 'number' => '7'), array('area' => '974', 'number' => '7'), array('area' => '975', 'number' => '8'), array('area' => '976', 'number' => '8'), array('area' => '977', 'number' => '9'), array('area' => '992', 'number' => '9'), array('area' => '993', 'number' => '8'), array('area' => '994', 'number' => '9'), array('area' => '995', 'number' => '8'), array('area' => '995', 'number' => '9'), array('area' => '996', 'number' => '9'), array('area' => '998', 'number' => '9'), array('area' => '1', 'number' => '9'), array('area' => '1', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '20', 'number' => '9'), array('area' => '27', 'number' => '6'), array('area' => '27', 'number' => '7'), array('area' => '27', 'number' => '8'), array('area' => '27', 'number' => '9'), array('area' => '27', 'number' => '10'), array('area' => '27', 'number' => '11'), array('area' => '27', 'number' => '12'), array('area' => '30', 'number' => '10'), array('area' => '31', 'number' => '9'), array('area' => '32', 'number' => '9'), array('area' => '33', 'number' => '9'), array('area' => '34', 'number' => '9'), array('area' => '36', 'number' => '9'), array('area' => '39', 'number' => '10'), array('area' => '40', 'number' => '9'), array('area' => '41', 'number' => '9'), array('area' => '43', 'number' => '10'), array('area' => '43', 'number' => '11'), array('area' => '44', 'number' => '10'), array('area' => '44', 'number' => '10'), array('area' => '45', 'number' => '8'), array('area' => '45', 'number' => '8'), array('area' => '46', 'number' => '9'), array('area' => '47', 'number' => '8'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '49', 'number' => '10'), array('area' => '49', 'number' => '11'), array('area' => '51', 'number' => '10'), array('area' => '51', 'number' => '11'), array('area' => '52', 'number' => '10'), array('area' => '53', 'number' => '7'), array('area' => '53', 'number' => '8'), array('area' => '53', 'number' => '9'), array('area' => '54', 'number' => '10'), array('area' => '55', 'number' => '10'), array('area' => '56', 'number' => '9'), array('area' => '57', 'number' => '10'), array('area' => '58', 'number' => '10'), array('area' => '60', 'number' => '8'), array('area' => '60', 'number' => '9'), array('area' => '61', 'number' => '9'), array('area' => '62', 'number' => '9'), array('area' => '62', 'number' => '10'), array('area' => '62', 'number' => '11'), array('area' => '63', 'number' => '9'), array('area' => '63', 'number' => '10'), array('area' => '64', 'number' => '8'), array('area' => '64', 'number' => '9'), array('area' => '64', 'number' => '10'), array('area' => '65', 'number' => '8'), array('area' => '66', 'number' => '9'), array('area' => '81', 'number' => '10'), array('area' => '82', 'number' => '9'), array('area' => '82', 'number' => '10'), array('area' => '84', 'number' => '9'), array('area' => '84', 'number' => '10'), array('area' => '86', 'number' => '11'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '91', 'number' => '10'), array('area' => '92', 'number' => '10'), array('area' => '93', 'number' => '9'), array('area' => '94', 'number' => '9'), array('area' => '95', 'number' => '8'), array('area' => '98', 'number' => '10'), array('area' => '212', 'number' => '9'), array('area' => '213', 'number' => '9'), array('area' => '216', 'number' => '8'), array('area' => '218', 'number' => '9'), array('area' => '220', 'number' => '7'), array('area' => '221', 'number' => '9'), array('area' => '222', 'number' => '7'), array('area' => '222', 'number' => '7'), array('area' => '223', 'number' => '8'), array('area' => '224', 'number' => '8'), array('area' => '225', 'number' => '8'), array('area' => '226', 'number' => '8'), array('area' => '227', 'number' => '8'), array('area' => '228', 'number' => '7'), array('area' => '229', 'number' => '8'), array('area' => '230', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '8'), array('area' => '232', 'number' => '8'), array('area' => '233', 'number' => '8'), array('area' => '233', 'number' => '9'), array('area' => '234', 'number' => '8'), array('area' => '234', 'number' => '10'), array('area' => '235', 'number' => '7'), array('area' => '236', 'number' => '8'), array('area' => '236', 'number' => '8'), array('area' => '237', 'number' => '8'), array('area' => '238', 'number' => '7'), array('area' => '239', 'number' => '6'), array('area' => '240', 'number' => '6'), array('area' => '241', 'number' => '8'), array('area' => '242', 'number' => '7'), array('area' => '243', 'number' => '9'), array('area' => '243', 'number' => '9'), array('area' => '244', 'number' => '9'), array('area' => '245', 'number' => '7'), array('area' => '248', 'number' => '6'), array('area' => '248', 'number' => '7'), array('area' => '249', 'number' => '9'), array('area' => '250', 'number' => '9'), array('area' => '251', 'number' => '9'), array('area' => '252', 'number' => '7'), array('area' => '252', 'number' => '7'), array('area' => '253', 'number' => '6'), array('area' => '254', 'number' => '9'), array('area' => '255', 'number' => '9'), array('area' => '256', 'number' => '9'), array('area' => '257', 'number' => '8'), array('area' => '258', 'number' => '9'), array('area' => '260', 'number' => '8'), array('area' => '261', 'number' => '9'), array('area' => '262', 'number' => '9'), array('area' => '263', 'number' => '6'), array('area' => '263', 'number' => '7'), array('area' => '263', 'number' => '8'), array('area' => '263', 'number' => '9'), array('area' => '263', 'number' => '10'), array('area' => '264', 'number' => '9'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '9'), array('area' => '266', 'number' => '8'), array('area' => '267', 'number' => '8'), array('area' => '268', 'number' => '7'), array('area' => '269', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '298', 'number' => '6'), array('area' => '299', 'number' => '6'), array('area' => '350', 'number' => '8'), array('area' => '351', 'number' => '9'), array('area' => '352', 'number' => '9'), array('area' => '352', 'number' => '10'), array('area' => '353', 'number' => '9'), array('area' => '353', 'number' => '10'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '9'), array('area' => '355', 'number' => '9'), array('area' => '356', 'number' => '8'), array('area' => '357', 'number' => '8'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '8'), array('area' => '358', 'number' => '9'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '11'), array('area' => '359', 'number' => '8'), array('area' => '359', 'number' => '9'), array('area' => '370', 'number' => '8'), array('area' => '370', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '372', 'number' => '8'), array('area' => '373', 'number' => '8'), array('area' => '374', 'number' => '8'), array('area' => '375', 'number' => '9'), array('area' => '375', 'number' => '9'), array('area' => '376', 'number' => '6'), array('area' => '377', 'number' => '8'), array('area' => '377', 'number' => '9'), array('area' => '378', 'number' => '9'), array('area' => '378', 'number' => '10'), array('area' => '378', 'number' => '11'), array('area' => '378', 'number' => '12'), array('area' => '378', 'number' => '13'), array('area' => '380', 'number' => '9'), array('area' => '381', 'number' => '8'), array('area' => '381', 'number' => '9'), array('area' => '382', 'number' => '7'), array('area' => '382', 'number' => '8'), array('area' => '382', 'number' => '9'), array('area' => '382', 'number' => '10'), array('area' => '385', 'number' => '8'), array('area' => '385', 'number' => '9'), array('area' => '386', 'number' => '8'), array('area' => '387', 'number' => '8'), array('area' => '389', 'number' => '8'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '423', 'number' => '7'), array('area' => '423', 'number' => '9'), array('area' => '500', 'number' => '5'), array('area' => '501', 'number' => '7'), array('area' => '502', 'number' => '8'), array('area' => '503', 'number' => '8'), array('area' => '504', 'number' => '8'), array('area' => '505', 'number' => '8'), array('area' => '506', 'number' => '8'), array('area' => '507', 'number' => '8'), array('area' => '508', 'number' => '6'), array('area' => '509', 'number' => '8'), array('area' => '590', 'number' => '9'), array('area' => '594', 'number' => '9'), array('area' => '591', 'number' => '8'), array('area' => '592', 'number' => '7'), array('area' => '593', 'number' => '8'), array('area' => '595', 'number' => '9'), array('area' => '596', 'number' => '9'), array('area' => '597', 'number' => '7'), array('area' => '598', 'number' => '8'), array('area' => '599', 'number' => '7'), array('area' => '599', 'number' => '8'), array('area' => '673', 'number' => '7'), array('area' => '674', 'number' => '7'), array('area' => '675', 'number' => '8'), array('area' => '676', 'number' => '5'), array('area' => '676', 'number' => '7'), array('area' => '677', 'number' => '5'), array('area' => '677', 'number' => '7'), array('area' => '678', 'number' => '7'), array('area' => '679', 'number' => '7'), array('area' => '680', 'number' => '7'), array('area' => '682', 'number' => '5'), array('area' => '685', 'number' => '7'), array('area' => '686', 'number' => '5'), array('area' => '686', 'number' => '5'), array('area' => '687', 'number' => '6'), array('area' => '688', 'number' => '5'), array('area' => '852', 'number' => '7'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '12'), array('area' => '853', 'number' => '8'), array('area' => '855', 'number' => '8'), array('area' => '856', 'number' => '9'), array('area' => '880', 'number' => '10'), array('area' => '886', 'number' => '8'), array('area' => '886', 'number' => '9'), array('area' => '960', 'number' => '7'), array('area' => '961', 'number' => '7'), array('area' => '962', 'number' => '9'), array('area' => '963', 'number' => '9'), array('area' => '964', 'number' => '10'), array('area' => '965', 'number' => '8'), array('area' => '966', 'number' => '9'), array('area' => '967', 'number' => '9'), array('area' => '968', 'number' => '8'), array('area' => '971', 'number' => '9'), array('area' => '972', 'number' => '9'), array('area' => '973', 'number' => '8'), array('area' => '973', 'number' => '8'), array('area' => '974', 'number' => '7'), array('area' => '974', 'number' => '7'), array('area' => '975', 'number' => '8'), array('area' => '976', 'number' => '8'), array('area' => '977', 'number' => '9'), array('area' => '992', 'number' => '9'), array('area' => '993', 'number' => '8'), array('area' => '994', 'number' => '9'), array('area' => '995', 'number' => '8'), array('area' => '995', 'number' => '9'), array('area' => '996', 'number' => '9'), array('area' => '998', 'number' => '9'), array('area' => '1', 'number' => '9'), array('area' => '1', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '20', 'number' => '9'), array('area' => '27', 'number' => '6'), array('area' => '27', 'number' => '7'), array('area' => '27', 'number' => '8'), array('area' => '27', 'number' => '9'), array('area' => '27', 'number' => '10'), array('area' => '27', 'number' => '11'), array('area' => '27', 'number' => '12'), array('area' => '30', 'number' => '10'), array('area' => '31', 'number' => '9'), array('area' => '32', 'number' => '9'), array('area' => '33', 'number' => '9'), array('area' => '34', 'number' => '9'), array('area' => '36', 'number' => '9'), array('area' => '39', 'number' => '10'), array('area' => '40', 'number' => '9'), array('area' => '41', 'number' => '9'), array('area' => '43', 'number' => '10'), array('area' => '43', 'number' => '11'), array('area' => '44', 'number' => '10'), array('area' => '44', 'number' => '10'), array('area' => '45', 'number' => '8'), array('area' => '45', 'number' => '8'), array('area' => '46', 'number' => '9'), array('area' => '47', 'number' => '8'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '49', 'number' => '10'), array('area' => '49', 'number' => '11'), array('area' => '51', 'number' => '10'), array('area' => '51', 'number' => '11'), array('area' => '52', 'number' => '10'), array('area' => '53', 'number' => '7'), array('area' => '53', 'number' => '8'), array('area' => '53', 'number' => '9'), array('area' => '54', 'number' => '10'), array('area' => '55', 'number' => '10'), array('area' => '56', 'number' => '9'), array('area' => '57', 'number' => '10'), array('area' => '58', 'number' => '10'), array('area' => '60', 'number' => '8'), array('area' => '60', 'number' => '9'), array('area' => '61', 'number' => '9'), array('area' => '62', 'number' => '9'), array('area' => '62', 'number' => '10'), array('area' => '62', 'number' => '11'), array('area' => '63', 'number' => '9'), array('area' => '63', 'number' => '10'), array('area' => '64', 'number' => '8'), array('area' => '64', 'number' => '9'), array('area' => '64', 'number' => '10'), array('area' => '65', 'number' => '8'), array('area' => '66', 'number' => '9'), array('area' => '81', 'number' => '10'), array('area' => '82', 'number' => '9'), array('area' => '82', 'number' => '10'), array('area' => '84', 'number' => '9'), array('area' => '84', 'number' => '10'), array('area' => '86', 'number' => '11'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '91', 'number' => '10'), array('area' => '92', 'number' => '10'), array('area' => '93', 'number' => '9'), array('area' => '94', 'number' => '9'), array('area' => '95', 'number' => '8'), array('area' => '98', 'number' => '10'), array('area' => '212', 'number' => '9'), array('area' => '213', 'number' => '9'), array('area' => '216', 'number' => '8'), array('area' => '218', 'number' => '9'), array('area' => '220', 'number' => '7'), array('area' => '221', 'number' => '9'), array('area' => '222', 'number' => '7'), array('area' => '222', 'number' => '7'), array('area' => '223', 'number' => '8'), array('area' => '224', 'number' => '8'), array('area' => '225', 'number' => '8'), array('area' => '226', 'number' => '8'), array('area' => '227', 'number' => '8'), array('area' => '228', 'number' => '7'), array('area' => '229', 'number' => '8'), array('area' => '230', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '8'), array('area' => '232', 'number' => '8'), array('area' => '233', 'number' => '8'), array('area' => '233', 'number' => '9'), array('area' => '234', 'number' => '8'), array('area' => '234', 'number' => '10'), array('area' => '235', 'number' => '7'), array('area' => '236', 'number' => '8'), array('area' => '236', 'number' => '8'), array('area' => '237', 'number' => '8'), array('area' => '238', 'number' => '7'), array('area' => '239', 'number' => '6'), array('area' => '240', 'number' => '6'), array('area' => '241', 'number' => '8'), array('area' => '242', 'number' => '7'), array('area' => '243', 'number' => '9'), array('area' => '243', 'number' => '9'), array('area' => '244', 'number' => '9'), array('area' => '245', 'number' => '7'), array('area' => '248', 'number' => '6'), array('area' => '248', 'number' => '7'), array('area' => '249', 'number' => '9'), array('area' => '250', 'number' => '9'), array('area' => '251', 'number' => '9'), array('area' => '252', 'number' => '7'), array('area' => '252', 'number' => '7'), array('area' => '253', 'number' => '6'), array('area' => '254', 'number' => '9'), array('area' => '255', 'number' => '9'), array('area' => '256', 'number' => '9'), array('area' => '257', 'number' => '8'), array('area' => '258', 'number' => '9'), array('area' => '260', 'number' => '8'), array('area' => '261', 'number' => '9'), array('area' => '262', 'number' => '9'), array('area' => '263', 'number' => '6'), array('area' => '263', 'number' => '7'), array('area' => '263', 'number' => '8'), array('area' => '263', 'number' => '9'), array('area' => '263', 'number' => '10'), array('area' => '264', 'number' => '9'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '9'), array('area' => '266', 'number' => '8'), array('area' => '267', 'number' => '8'), array('area' => '268', 'number' => '7'), array('area' => '269', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '298', 'number' => '6'), array('area' => '299', 'number' => '6'), array('area' => '350', 'number' => '8'), array('area' => '351', 'number' => '9'), array('area' => '352', 'number' => '9'), array('area' => '352', 'number' => '10'), array('area' => '353', 'number' => '9'), array('area' => '353', 'number' => '10'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '9'), array('area' => '355', 'number' => '9'), array('area' => '356', 'number' => '8'), array('area' => '357', 'number' => '8'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '8'), array('area' => '358', 'number' => '9'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '11'), array('area' => '359', 'number' => '8'), array('area' => '359', 'number' => '9'), array('area' => '370', 'number' => '8'), array('area' => '370', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '372', 'number' => '8'), array('area' => '373', 'number' => '8'), array('area' => '374', 'number' => '8'), array('area' => '375', 'number' => '9'), array('area' => '375', 'number' => '9'), array('area' => '376', 'number' => '6'), array('area' => '377', 'number' => '8'), array('area' => '377', 'number' => '9'), array('area' => '378', 'number' => '9'), array('area' => '378', 'number' => '10'), array('area' => '378', 'number' => '11'), array('area' => '378', 'number' => '12'), array('area' => '378', 'number' => '13'), array('area' => '380', 'number' => '9'), array('area' => '381', 'number' => '8'), array('area' => '381', 'number' => '9'), array('area' => '382', 'number' => '7'), array('area' => '382', 'number' => '8'), array('area' => '382', 'number' => '9'), array('area' => '382', 'number' => '10'), array('area' => '385', 'number' => '8'), array('area' => '385', 'number' => '9'), array('area' => '386', 'number' => '8'), array('area' => '387', 'number' => '8'), array('area' => '389', 'number' => '8'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '423', 'number' => '7'), array('area' => '423', 'number' => '9'), array('area' => '500', 'number' => '5'), array('area' => '501', 'number' => '7'), array('area' => '502', 'number' => '8'), array('area' => '503', 'number' => '8'), array('area' => '504', 'number' => '8'), array('area' => '505', 'number' => '8'), array('area' => '506', 'number' => '8'), array('area' => '507', 'number' => '8'), array('area' => '508', 'number' => '6'), array('area' => '509', 'number' => '8'), array('area' => '590', 'number' => '9'), array('area' => '594', 'number' => '9'), array('area' => '591', 'number' => '8'), array('area' => '592', 'number' => '7'), array('area' => '593', 'number' => '8'), array('area' => '595', 'number' => '9'), array('area' => '596', 'number' => '9'), array('area' => '597', 'number' => '7'), array('area' => '598', 'number' => '8'), array('area' => '599', 'number' => '7'), array('area' => '599', 'number' => '8'), array('area' => '673', 'number' => '7'), array('area' => '674', 'number' => '7'), array('area' => '675', 'number' => '8'), array('area' => '676', 'number' => '5'), array('area' => '676', 'number' => '7'), array('area' => '677', 'number' => '5'), array('area' => '677', 'number' => '7'), array('area' => '678', 'number' => '7'), array('area' => '679', 'number' => '7'), array('area' => '680', 'number' => '7'), array('area' => '682', 'number' => '5'), array('area' => '685', 'number' => '7'), array('area' => '686', 'number' => '5'), array('area' => '686', 'number' => '5'), array('area' => '687', 'number' => '6'), array('area' => '688', 'number' => '5'), array('area' => '852', 'number' => '7'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '12'), array('area' => '853', 'number' => '8'), array('area' => '855', 'number' => '8'), array('area' => '856', 'number' => '9'), array('area' => '880', 'number' => '10'), array('area' => '886', 'number' => '8'), array('area' => '886', 'number' => '9'), array('area' => '960', 'number' => '7'), array('area' => '961', 'number' => '7'), array('area' => '962', 'number' => '9'), array('area' => '963', 'number' => '9'), array('area' => '964', 'number' => '10'), array('area' => '965', 'number' => '8'), array('area' => '966', 'number' => '9'), array('area' => '967', 'number' => '9'), array('area' => '968', 'number' => '8'), array('area' => '971', 'number' => '9'), array('area' => '972', 'number' => '9'), array('area' => '973', 'number' => '8'), array('area' => '973', 'number' => '8'), array('area' => '974', 'number' => '7'), array('area' => '974', 'number' => '7'), array('area' => '975', 'number' => '8'), array('area' => '976', 'number' => '8'), array('area' => '977', 'number' => '9'), array('area' => '992', 'number' => '9'), array('area' => '993', 'number' => '8'), array('area' => '994', 'number' => '9'), array('area' => '995', 'number' => '8'), array('area' => '995', 'number' => '9'), array('area' => '996', 'number' => '9'), array('area' => '998', 'number' => '9'), array('area' => '1', 'number' => '9'), array('area' => '1', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '20', 'number' => '9'), array('area' => '27', 'number' => '6'), array('area' => '27', 'number' => '7'), array('area' => '27', 'number' => '8'), array('area' => '27', 'number' => '9'), array('area' => '27', 'number' => '10'), array('area' => '27', 'number' => '11'), array('area' => '27', 'number' => '12'), array('area' => '30', 'number' => '10'), array('area' => '31', 'number' => '9'), array('area' => '32', 'number' => '9'), array('area' => '33', 'number' => '9'), array('area' => '34', 'number' => '9'), array('area' => '36', 'number' => '9'), array('area' => '39', 'number' => '10'), array('area' => '40', 'number' => '9'), array('area' => '41', 'number' => '9'), array('area' => '43', 'number' => '10'), array('area' => '43', 'number' => '11'), array('area' => '44', 'number' => '10'), array('area' => '44', 'number' => '10'), array('area' => '45', 'number' => '8'), array('area' => '45', 'number' => '8'), array('area' => '46', 'number' => '9'), array('area' => '47', 'number' => '8'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '49', 'number' => '10'), array('area' => '49', 'number' => '11'), array('area' => '51', 'number' => '10'), array('area' => '51', 'number' => '11'), array('area' => '52', 'number' => '10'), array('area' => '53', 'number' => '7'), array('area' => '53', 'number' => '8'), array('area' => '53', 'number' => '9'), array('area' => '54', 'number' => '10'), array('area' => '55', 'number' => '10'), array('area' => '56', 'number' => '9'), array('area' => '57', 'number' => '10'), array('area' => '58', 'number' => '10'), array('area' => '60', 'number' => '8'), array('area' => '60', 'number' => '9'), array('area' => '61', 'number' => '9'), array('area' => '62', 'number' => '9'), array('area' => '62', 'number' => '10'), array('area' => '62', 'number' => '11'), array('area' => '63', 'number' => '9'), array('area' => '63', 'number' => '10'), array('area' => '64', 'number' => '8'), array('area' => '64', 'number' => '9'), array('area' => '64', 'number' => '10'), array('area' => '65', 'number' => '8'), array('area' => '66', 'number' => '9'), array('area' => '81', 'number' => '10'), array('area' => '82', 'number' => '9'), array('area' => '82', 'number' => '10'), array('area' => '84', 'number' => '9'), array('area' => '84', 'number' => '10'), array('area' => '86', 'number' => '11'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '91', 'number' => '10'), array('area' => '92', 'number' => '10'), array('area' => '93', 'number' => '9'), array('area' => '94', 'number' => '9'), array('area' => '95', 'number' => '8'), array('area' => '98', 'number' => '10'), array('area' => '212', 'number' => '9'), array('area' => '213', 'number' => '9'), array('area' => '216', 'number' => '8'), array('area' => '218', 'number' => '9'), array('area' => '220', 'number' => '7'), array('area' => '221', 'number' => '9'), array('area' => '222', 'number' => '7'), array('area' => '222', 'number' => '7'), array('area' => '223', 'number' => '8'), array('area' => '224', 'number' => '8'), array('area' => '225', 'number' => '8'), array('area' => '226', 'number' => '8'), array('area' => '227', 'number' => '8'), array('area' => '228', 'number' => '7'), array('area' => '229', 'number' => '8'), array('area' => '230', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '8'), array('area' => '232', 'number' => '8'), array('area' => '233', 'number' => '8'), array('area' => '233', 'number' => '9'), array('area' => '234', 'number' => '8'), array('area' => '234', 'number' => '10'), array('area' => '235', 'number' => '7'), array('area' => '236', 'number' => '8'), array('area' => '236', 'number' => '8'), array('area' => '237', 'number' => '8'), array('area' => '238', 'number' => '7'), array('area' => '239', 'number' => '6'), array('area' => '240', 'number' => '6'), array('area' => '241', 'number' => '8'), array('area' => '242', 'number' => '7'), array('area' => '243', 'number' => '9'), array('area' => '243', 'number' => '9'), array('area' => '244', 'number' => '9'), array('area' => '245', 'number' => '7'), array('area' => '248', 'number' => '6'), array('area' => '248', 'number' => '7'), array('area' => '249', 'number' => '9'), array('area' => '250', 'number' => '9'), array('area' => '251', 'number' => '9'), array('area' => '252', 'number' => '7'), array('area' => '252', 'number' => '7'), array('area' => '253', 'number' => '6'), array('area' => '254', 'number' => '9'), array('area' => '255', 'number' => '9'), array('area' => '256', 'number' => '9'), array('area' => '257', 'number' => '8'), array('area' => '258', 'number' => '9'), array('area' => '260', 'number' => '8'), array('area' => '261', 'number' => '9'), array('area' => '262', 'number' => '9'), array('area' => '263', 'number' => '6'), array('area' => '263', 'number' => '7'), array('area' => '263', 'number' => '8'), array('area' => '263', 'number' => '9'), array('area' => '263', 'number' => '10'), array('area' => '264', 'number' => '9'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '9'), array('area' => '266', 'number' => '8'), array('area' => '267', 'number' => '8'), array('area' => '268', 'number' => '7'), array('area' => '269', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '298', 'number' => '6'), array('area' => '299', 'number' => '6'), array('area' => '350', 'number' => '8'), array('area' => '351', 'number' => '9'), array('area' => '352', 'number' => '9'), array('area' => '352', 'number' => '10'), array('area' => '353', 'number' => '9'), array('area' => '353', 'number' => '10'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '9'), array('area' => '355', 'number' => '9'), array('area' => '356', 'number' => '8'), array('area' => '357', 'number' => '8'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '8'), array('area' => '358', 'number' => '9'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '11'), array('area' => '359', 'number' => '8'), array('area' => '359', 'number' => '9'), array('area' => '370', 'number' => '8'), array('area' => '370', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '372', 'number' => '8'), array('area' => '373', 'number' => '8'), array('area' => '374', 'number' => '8'), array('area' => '375', 'number' => '9'), array('area' => '375', 'number' => '9'), array('area' => '376', 'number' => '6'), array('area' => '377', 'number' => '8'), array('area' => '377', 'number' => '9'), array('area' => '378', 'number' => '9'), array('area' => '378', 'number' => '10'), array('area' => '378', 'number' => '11'), array('area' => '378', 'number' => '12'), array('area' => '378', 'number' => '13'), array('area' => '380', 'number' => '9'), array('area' => '381', 'number' => '8'), array('area' => '381', 'number' => '9'), array('area' => '382', 'number' => '7'), array('area' => '382', 'number' => '8'), array('area' => '382', 'number' => '9'), array('area' => '382', 'number' => '10'), array('area' => '385', 'number' => '8'), array('area' => '385', 'number' => '9'), array('area' => '386', 'number' => '8'), array('area' => '387', 'number' => '8'), array('area' => '389', 'number' => '8'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '423', 'number' => '7'), array('area' => '423', 'number' => '9'), array('area' => '500', 'number' => '5'), array('area' => '501', 'number' => '7'), array('area' => '502', 'number' => '8'), array('area' => '503', 'number' => '8'), array('area' => '504', 'number' => '8'), array('area' => '505', 'number' => '8'), array('area' => '506', 'number' => '8'), array('area' => '507', 'number' => '8'), array('area' => '508', 'number' => '6'), array('area' => '509', 'number' => '8'), array('area' => '590', 'number' => '9'), array('area' => '594', 'number' => '9'), array('area' => '591', 'number' => '8'), array('area' => '592', 'number' => '7'), array('area' => '593', 'number' => '8'), array('area' => '595', 'number' => '9'), array('area' => '596', 'number' => '9'), array('area' => '597', 'number' => '7'), array('area' => '598', 'number' => '8'), array('area' => '599', 'number' => '7'), array('area' => '599', 'number' => '8'), array('area' => '673', 'number' => '7'), array('area' => '674', 'number' => '7'), array('area' => '675', 'number' => '8'), array('area' => '676', 'number' => '5'), array('area' => '676', 'number' => '7'), array('area' => '677', 'number' => '5'), array('area' => '677', 'number' => '7'), array('area' => '678', 'number' => '7'), array('area' => '679', 'number' => '7'), array('area' => '680', 'number' => '7'), array('area' => '682', 'number' => '5'), array('area' => '685', 'number' => '7'), array('area' => '686', 'number' => '5'), array('area' => '686', 'number' => '5'), array('area' => '687', 'number' => '6'), array('area' => '688', 'number' => '5'), array('area' => '852', 'number' => '7'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '12'), array('area' => '853', 'number' => '8'), array('area' => '855', 'number' => '8'), array('area' => '856', 'number' => '9'), array('area' => '880', 'number' => '10'), array('area' => '886', 'number' => '8'), array('area' => '886', 'number' => '9'), array('area' => '960', 'number' => '7'), array('area' => '961', 'number' => '7'), array('area' => '962', 'number' => '9'), array('area' => '963', 'number' => '9'), array('area' => '964', 'number' => '10'), array('area' => '965', 'number' => '8'), array('area' => '966', 'number' => '9'), array('area' => '967', 'number' => '9'), array('area' => '968', 'number' => '8'), array('area' => '971', 'number' => '9'), array('area' => '972', 'number' => '9'), array('area' => '973', 'number' => '8'), array('area' => '973', 'number' => '8'), array('area' => '974', 'number' => '7'), array('area' => '974', 'number' => '7'), array('area' => '975', 'number' => '8'), array('area' => '976', 'number' => '8'), array('area' => '977', 'number' => '9'), array('area' => '992', 'number' => '9'), array('area' => '993', 'number' => '8'), array('area' => '994', 'number' => '9'), array('area' => '995', 'number' => '8'), array('area' => '995', 'number' => '9'), array('area' => '996', 'number' => '9'), array('area' => '998', 'number' => '9'), array('area' => '1', 'number' => '9'), array('area' => '1', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '20', 'number' => '9'), array('area' => '27', 'number' => '6'), array('area' => '27', 'number' => '7'), array('area' => '27', 'number' => '8'), array('area' => '27', 'number' => '9'), array('area' => '27', 'number' => '10'), array('area' => '27', 'number' => '11'), array('area' => '27', 'number' => '12'), array('area' => '30', 'number' => '10'), array('area' => '31', 'number' => '9'), array('area' => '32', 'number' => '9'), array('area' => '33', 'number' => '9'), array('area' => '34', 'number' => '9'), array('area' => '36', 'number' => '9'), array('area' => '39', 'number' => '10'), array('area' => '40', 'number' => '9'), array('area' => '41', 'number' => '9'), array('area' => '43', 'number' => '10'), array('area' => '43', 'number' => '11'), array('area' => '44', 'number' => '10'), array('area' => '44', 'number' => '10'), array('area' => '45', 'number' => '8'), array('area' => '45', 'number' => '8'), array('area' => '46', 'number' => '9'), array('area' => '47', 'number' => '8'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '49', 'number' => '10'), array('area' => '49', 'number' => '11'), array('area' => '51', 'number' => '10'), array('area' => '51', 'number' => '11'), array('area' => '52', 'number' => '10'), array('area' => '53', 'number' => '7'), array('area' => '53', 'number' => '8'), array('area' => '53', 'number' => '9'), array('area' => '54', 'number' => '10'), array('area' => '55', 'number' => '10'), array('area' => '56', 'number' => '9'), array('area' => '57', 'number' => '10'), array('area' => '58', 'number' => '10'), array('area' => '60', 'number' => '8'), array('area' => '60', 'number' => '9'), array('area' => '61', 'number' => '9'), array('area' => '62', 'number' => '9'), array('area' => '62', 'number' => '10'), array('area' => '62', 'number' => '11'), array('area' => '63', 'number' => '9'), array('area' => '63', 'number' => '10'), array('area' => '64', 'number' => '8'), array('area' => '64', 'number' => '9'), array('area' => '64', 'number' => '10'), array('area' => '65', 'number' => '8'), array('area' => '66', 'number' => '9'), array('area' => '81', 'number' => '10'), array('area' => '82', 'number' => '9'), array('area' => '82', 'number' => '10'), array('area' => '84', 'number' => '9'), array('area' => '84', 'number' => '10'), array('area' => '86', 'number' => '11'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '91', 'number' => '10'), array('area' => '92', 'number' => '10'), array('area' => '93', 'number' => '9'), array('area' => '94', 'number' => '9'), array('area' => '95', 'number' => '8'), array('area' => '98', 'number' => '10'), array('area' => '212', 'number' => '9'), array('area' => '213', 'number' => '9'), array('area' => '216', 'number' => '8'), array('area' => '218', 'number' => '9'), array('area' => '220', 'number' => '7'), array('area' => '221', 'number' => '9'), array('area' => '222', 'number' => '7'), array('area' => '222', 'number' => '7'), array('area' => '223', 'number' => '8'), array('area' => '224', 'number' => '8'), array('area' => '225', 'number' => '8'), array('area' => '226', 'number' => '8'), array('area' => '227', 'number' => '8'), array('area' => '228', 'number' => '7'), array('area' => '229', 'number' => '8'), array('area' => '230', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '8'), array('area' => '232', 'number' => '8'), array('area' => '233', 'number' => '8'), array('area' => '233', 'number' => '9'), array('area' => '234', 'number' => '8'), array('area' => '234', 'number' => '10'), array('area' => '235', 'number' => '7'), array('area' => '236', 'number' => '8'), array('area' => '236', 'number' => '8'), array('area' => '237', 'number' => '8'), array('area' => '238', 'number' => '7'), array('area' => '239', 'number' => '6'), array('area' => '240', 'number' => '6'), array('area' => '241', 'number' => '8'), array('area' => '242', 'number' => '7'), array('area' => '243', 'number' => '9'), array('area' => '243', 'number' => '9'), array('area' => '244', 'number' => '9'), array('area' => '245', 'number' => '7'), array('area' => '248', 'number' => '6'), array('area' => '248', 'number' => '7'), array('area' => '249', 'number' => '9'), array('area' => '250', 'number' => '9'), array('area' => '251', 'number' => '9'), array('area' => '252', 'number' => '7'), array('area' => '252', 'number' => '7'), array('area' => '253', 'number' => '6'), array('area' => '254', 'number' => '9'), array('area' => '255', 'number' => '9'), array('area' => '256', 'number' => '9'), array('area' => '257', 'number' => '8'), array('area' => '258', 'number' => '9'), array('area' => '260', 'number' => '8'), array('area' => '261', 'number' => '9'), array('area' => '262', 'number' => '9'), array('area' => '263', 'number' => '6'), array('area' => '263', 'number' => '7'), array('area' => '263', 'number' => '8'), array('area' => '263', 'number' => '9'), array('area' => '263', 'number' => '10'), array('area' => '264', 'number' => '9'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '9'), array('area' => '266', 'number' => '8'), array('area' => '267', 'number' => '8'), array('area' => '268', 'number' => '7'), array('area' => '269', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '298', 'number' => '6'), array('area' => '299', 'number' => '6'), array('area' => '350', 'number' => '8'), array('area' => '351', 'number' => '9'), array('area' => '352', 'number' => '9'), array('area' => '352', 'number' => '10'), array('area' => '353', 'number' => '9'), array('area' => '353', 'number' => '10'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '9'), array('area' => '355', 'number' => '9'), array('area' => '356', 'number' => '8'), array('area' => '357', 'number' => '8'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '8'), array('area' => '358', 'number' => '9'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '11'), array('area' => '359', 'number' => '8'), array('area' => '359', 'number' => '9'), array('area' => '370', 'number' => '8'), array('area' => '370', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '372', 'number' => '8'), array('area' => '373', 'number' => '8'), array('area' => '374', 'number' => '8'), array('area' => '375', 'number' => '9'), array('area' => '375', 'number' => '9'), array('area' => '376', 'number' => '6'), array('area' => '377', 'number' => '8'), array('area' => '377', 'number' => '9'), array('area' => '378', 'number' => '9'), array('area' => '378', 'number' => '10'), array('area' => '378', 'number' => '11'), array('area' => '378', 'number' => '12'), array('area' => '378', 'number' => '13'), array('area' => '380', 'number' => '9'), array('area' => '381', 'number' => '8'), array('area' => '381', 'number' => '9'), array('area' => '382', 'number' => '7'), array('area' => '382', 'number' => '8'), array('area' => '382', 'number' => '9'), array('area' => '382', 'number' => '10'), array('area' => '385', 'number' => '8'), array('area' => '385', 'number' => '9'), array('area' => '386', 'number' => '8'), array('area' => '387', 'number' => '8'), array('area' => '389', 'number' => '8'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '423', 'number' => '7'), array('area' => '423', 'number' => '9'), array('area' => '500', 'number' => '5'), array('area' => '501', 'number' => '7'), array('area' => '502', 'number' => '8'), array('area' => '503', 'number' => '8'), array('area' => '504', 'number' => '8'), array('area' => '505', 'number' => '8'), array('area' => '506', 'number' => '8'), array('area' => '507', 'number' => '8'), array('area' => '508', 'number' => '6'), array('area' => '509', 'number' => '8'), array('area' => '590', 'number' => '9'), array('area' => '594', 'number' => '9'), array('area' => '591', 'number' => '8'), array('area' => '592', 'number' => '7'), array('area' => '593', 'number' => '8'), array('area' => '595', 'number' => '9'), array('area' => '596', 'number' => '9'), array('area' => '597', 'number' => '7'), array('area' => '598', 'number' => '8'), array('area' => '599', 'number' => '7'), array('area' => '599', 'number' => '8'), array('area' => '673', 'number' => '7'), array('area' => '674', 'number' => '7'), array('area' => '675', 'number' => '8'), array('area' => '676', 'number' => '5'), array('area' => '676', 'number' => '7'), array('area' => '677', 'number' => '5'), array('area' => '677', 'number' => '7'), array('area' => '678', 'number' => '7'), array('area' => '679', 'number' => '7'), array('area' => '680', 'number' => '7'), array('area' => '682', 'number' => '5'), array('area' => '685', 'number' => '7'), array('area' => '686', 'number' => '5'), array('area' => '686', 'number' => '5'), array('area' => '687', 'number' => '6'), array('area' => '688', 'number' => '5'), array('area' => '852', 'number' => '7'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '12'), array('area' => '853', 'number' => '8'), array('area' => '855', 'number' => '8'), array('area' => '856', 'number' => '9'), array('area' => '880', 'number' => '10'), array('area' => '886', 'number' => '8'), array('area' => '886', 'number' => '9'), array('area' => '960', 'number' => '7'), array('area' => '961', 'number' => '7'), array('area' => '962', 'number' => '9'), array('area' => '963', 'number' => '9'), array('area' => '964', 'number' => '10'), array('area' => '965', 'number' => '8'), array('area' => '966', 'number' => '9'), array('area' => '967', 'number' => '9'), array('area' => '968', 'number' => '8'), array('area' => '971', 'number' => '9'), array('area' => '972', 'number' => '9'), array('area' => '973', 'number' => '8'), array('area' => '973', 'number' => '8'), array('area' => '974', 'number' => '7'), array('area' => '974', 'number' => '7'), array('area' => '975', 'number' => '8'), array('area' => '976', 'number' => '8'), array('area' => '977', 'number' => '9'), array('area' => '992', 'number' => '9'), array('area' => '993', 'number' => '8'), array('area' => '994', 'number' => '9'), array('area' => '995', 'number' => '8'), array('area' => '995', 'number' => '9'), array('area' => '996', 'number' => '9'), array('area' => '998', 'number' => '9'), array('area' => '1', 'number' => '9'), array('area' => '1', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '20', 'number' => '9'), array('area' => '27', 'number' => '6'), array('area' => '27', 'number' => '7'), array('area' => '27', 'number' => '8'), array('area' => '27', 'number' => '9'), array('area' => '27', 'number' => '10'), array('area' => '27', 'number' => '11'), array('area' => '27', 'number' => '12'), array('area' => '30', 'number' => '10'), array('area' => '31', 'number' => '9'), array('area' => '32', 'number' => '9'), array('area' => '33', 'number' => '9'), array('area' => '34', 'number' => '9'), array('area' => '36', 'number' => '9'), array('area' => '39', 'number' => '10'), array('area' => '40', 'number' => '9'), array('area' => '41', 'number' => '9'), array('area' => '43', 'number' => '10'), array('area' => '43', 'number' => '11'), array('area' => '44', 'number' => '10'), array('area' => '44', 'number' => '10'), array('area' => '45', 'number' => '8'), array('area' => '45', 'number' => '8'), array('area' => '46', 'number' => '9'), array('area' => '47', 'number' => '8'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '49', 'number' => '10'), array('area' => '49', 'number' => '11'), array('area' => '51', 'number' => '10'), array('area' => '51', 'number' => '11'), array('area' => '52', 'number' => '10'), array('area' => '53', 'number' => '7'), array('area' => '53', 'number' => '8'), array('area' => '53', 'number' => '9'), array('area' => '54', 'number' => '10'), array('area' => '55', 'number' => '10'), array('area' => '56', 'number' => '9'), array('area' => '57', 'number' => '10'), array('area' => '58', 'number' => '10'), array('area' => '60', 'number' => '8'), array('area' => '60', 'number' => '9'), array('area' => '61', 'number' => '9'), array('area' => '62', 'number' => '9'), array('area' => '62', 'number' => '10'), array('area' => '62', 'number' => '11'), array('area' => '63', 'number' => '9'), array('area' => '63', 'number' => '10'), array('area' => '64', 'number' => '8'), array('area' => '64', 'number' => '9'), array('area' => '64', 'number' => '10'), array('area' => '65', 'number' => '8'), array('area' => '66', 'number' => '9'), array('area' => '81', 'number' => '10'), array('area' => '82', 'number' => '9'), array('area' => '82', 'number' => '10'), array('area' => '84', 'number' => '9'), array('area' => '84', 'number' => '10'), array('area' => '86', 'number' => '11'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '91', 'number' => '10'), array('area' => '92', 'number' => '10'), array('area' => '93', 'number' => '9'), array('area' => '94', 'number' => '9'), array('area' => '95', 'number' => '8'), array('area' => '98', 'number' => '10'), array('area' => '212', 'number' => '9'), array('area' => '213', 'number' => '9'), array('area' => '216', 'number' => '8'), array('area' => '218', 'number' => '9'), array('area' => '220', 'number' => '7'), array('area' => '221', 'number' => '9'), array('area' => '222', 'number' => '7'), array('area' => '222', 'number' => '7'), array('area' => '223', 'number' => '8'), array('area' => '224', 'number' => '8'), array('area' => '225', 'number' => '8'), array('area' => '226', 'number' => '8'), array('area' => '227', 'number' => '8'), array('area' => '228', 'number' => '7'), array('area' => '229', 'number' => '8'), array('area' => '230', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '8'), array('area' => '232', 'number' => '8'), array('area' => '233', 'number' => '8'), array('area' => '233', 'number' => '9'), array('area' => '234', 'number' => '8'), array('area' => '234', 'number' => '10'), array('area' => '235', 'number' => '7'), array('area' => '236', 'number' => '8'), array('area' => '236', 'number' => '8'), array('area' => '237', 'number' => '8'), array('area' => '238', 'number' => '7'), array('area' => '239', 'number' => '6'), array('area' => '240', 'number' => '6'), array('area' => '241', 'number' => '8'), array('area' => '242', 'number' => '7'), array('area' => '243', 'number' => '9'), array('area' => '243', 'number' => '9'), array('area' => '244', 'number' => '9'), array('area' => '245', 'number' => '7'), array('area' => '248', 'number' => '6'), array('area' => '248', 'number' => '7'), array('area' => '249', 'number' => '9'), array('area' => '250', 'number' => '9'), array('area' => '251', 'number' => '9'), array('area' => '252', 'number' => '7'), array('area' => '252', 'number' => '7'), array('area' => '253', 'number' => '6'), array('area' => '254', 'number' => '9'), array('area' => '255', 'number' => '9'), array('area' => '256', 'number' => '9'), array('area' => '257', 'number' => '8'), array('area' => '258', 'number' => '9'), array('area' => '260', 'number' => '8'), array('area' => '261', 'number' => '9'), array('area' => '262', 'number' => '9'), array('area' => '263', 'number' => '6'), array('area' => '263', 'number' => '7'), array('area' => '263', 'number' => '8'), array('area' => '263', 'number' => '9'), array('area' => '263', 'number' => '10'), array('area' => '264', 'number' => '9'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '9'), array('area' => '266', 'number' => '8'), array('area' => '267', 'number' => '8'), array('area' => '268', 'number' => '7'), array('area' => '269', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '298', 'number' => '6'), array('area' => '299', 'number' => '6'), array('area' => '350', 'number' => '8'), array('area' => '351', 'number' => '9'), array('area' => '352', 'number' => '9'), array('area' => '352', 'number' => '10'), array('area' => '353', 'number' => '9'), array('area' => '353', 'number' => '10'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '9'), array('area' => '355', 'number' => '9'), array('area' => '356', 'number' => '8'), array('area' => '357', 'number' => '8'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '8'), array('area' => '358', 'number' => '9'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '11'), array('area' => '359', 'number' => '8'), array('area' => '359', 'number' => '9'), array('area' => '370', 'number' => '8'), array('area' => '370', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '372', 'number' => '8'), array('area' => '373', 'number' => '8'), array('area' => '374', 'number' => '8'), array('area' => '375', 'number' => '9'), array('area' => '375', 'number' => '9'), array('area' => '376', 'number' => '6'), array('area' => '377', 'number' => '8'), array('area' => '377', 'number' => '9'), array('area' => '378', 'number' => '9'), array('area' => '378', 'number' => '10'), array('area' => '378', 'number' => '11'), array('area' => '378', 'number' => '12'), array('area' => '378', 'number' => '13'), array('area' => '380', 'number' => '9'), array('area' => '381', 'number' => '8'), array('area' => '381', 'number' => '9'), array('area' => '382', 'number' => '7'), array('area' => '382', 'number' => '8'), array('area' => '382', 'number' => '9'), array('area' => '382', 'number' => '10'), array('area' => '385', 'number' => '8'), array('area' => '385', 'number' => '9'), array('area' => '386', 'number' => '8'), array('area' => '387', 'number' => '8'), array('area' => '389', 'number' => '8'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '423', 'number' => '7'), array('area' => '423', 'number' => '9'), array('area' => '500', 'number' => '5'), array('area' => '501', 'number' => '7'), array('area' => '502', 'number' => '8'), array('area' => '503', 'number' => '8'), array('area' => '504', 'number' => '8'), array('area' => '505', 'number' => '8'), array('area' => '506', 'number' => '8'), array('area' => '507', 'number' => '8'), array('area' => '508', 'number' => '6'), array('area' => '509', 'number' => '8'), array('area' => '590', 'number' => '9'), array('area' => '594', 'number' => '9'), array('area' => '591', 'number' => '8'), array('area' => '592', 'number' => '7'), array('area' => '593', 'number' => '8'), array('area' => '595', 'number' => '9'), array('area' => '596', 'number' => '9'), array('area' => '597', 'number' => '7'), array('area' => '598', 'number' => '8'), array('area' => '599', 'number' => '7'), array('area' => '599', 'number' => '8'), array('area' => '673', 'number' => '7'), array('area' => '674', 'number' => '7'), array('area' => '675', 'number' => '8'), array('area' => '676', 'number' => '5'), array('area' => '676', 'number' => '7'), array('area' => '677', 'number' => '5'), array('area' => '677', 'number' => '7'), array('area' => '678', 'number' => '7'), array('area' => '679', 'number' => '7'), array('area' => '680', 'number' => '7'), array('area' => '682', 'number' => '5'), array('area' => '685', 'number' => '7'), array('area' => '686', 'number' => '5'), array('area' => '686', 'number' => '5'), array('area' => '687', 'number' => '6'), array('area' => '688', 'number' => '5'), array('area' => '852', 'number' => '7'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '12'), array('area' => '853', 'number' => '8'), array('area' => '855', 'number' => '8'), array('area' => '856', 'number' => '9'), array('area' => '880', 'number' => '10'), array('area' => '886', 'number' => '8'), array('area' => '886', 'number' => '9'), array('area' => '960', 'number' => '7'), array('area' => '961', 'number' => '7'), array('area' => '962', 'number' => '9'), array('area' => '963', 'number' => '9'), array('area' => '964', 'number' => '10'), array('area' => '965', 'number' => '8'), array('area' => '966', 'number' => '9'), array('area' => '967', 'number' => '9'), array('area' => '968', 'number' => '8'), array('area' => '971', 'number' => '9'), array('area' => '972', 'number' => '9'), array('area' => '973', 'number' => '8'), array('area' => '973', 'number' => '8'), array('area' => '974', 'number' => '7'), array('area' => '974', 'number' => '7'), array('area' => '975', 'number' => '8'), array('area' => '976', 'number' => '8'), array('area' => '977', 'number' => '9'), array('area' => '992', 'number' => '9'), array('area' => '993', 'number' => '8'), array('area' => '994', 'number' => '9'), array('area' => '995', 'number' => '8'), array('area' => '995', 'number' => '9'), array('area' => '996', 'number' => '9'), array('area' => '998', 'number' => '9'), array('area' => '1', 'number' => '9'), array('area' => '1', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '7', 'number' => '10'), array('area' => '20', 'number' => '9'), array('area' => '27', 'number' => '6'), array('area' => '27', 'number' => '7'), array('area' => '27', 'number' => '8'), array('area' => '27', 'number' => '9'), array('area' => '27', 'number' => '10'), array('area' => '27', 'number' => '11'), array('area' => '27', 'number' => '12'), array('area' => '30', 'number' => '10'), array('area' => '31', 'number' => '9'), array('area' => '32', 'number' => '9'), array('area' => '33', 'number' => '9'), array('area' => '34', 'number' => '9'), array('area' => '36', 'number' => '9'), array('area' => '39', 'number' => '10'), array('area' => '40', 'number' => '9'), array('area' => '41', 'number' => '9'), array('area' => '43', 'number' => '10'), array('area' => '43', 'number' => '11'), array('area' => '44', 'number' => '10'), array('area' => '44', 'number' => '10'), array('area' => '45', 'number' => '8'), array('area' => '45', 'number' => '8'), array('area' => '46', 'number' => '9'), array('area' => '47', 'number' => '8'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '48', 'number' => '9'), array('area' => '49', 'number' => '10'), array('area' => '49', 'number' => '11'), array('area' => '51', 'number' => '10'), array('area' => '51', 'number' => '11'), array('area' => '52', 'number' => '10'), array('area' => '53', 'number' => '7'), array('area' => '53', 'number' => '8'), array('area' => '53', 'number' => '9'), array('area' => '54', 'number' => '10'), array('area' => '55', 'number' => '10'), array('area' => '56', 'number' => '9'), array('area' => '57', 'number' => '10'), array('area' => '58', 'number' => '10'), array('area' => '60', 'number' => '8'), array('area' => '60', 'number' => '9'), array('area' => '61', 'number' => '9'), array('area' => '62', 'number' => '9'), array('area' => '62', 'number' => '10'), array('area' => '62', 'number' => '11'), array('area' => '63', 'number' => '9'), array('area' => '63', 'number' => '10'), array('area' => '64', 'number' => '8'), array('area' => '64', 'number' => '9'), array('area' => '64', 'number' => '10'), array('area' => '65', 'number' => '8'), array('area' => '66', 'number' => '9'), array('area' => '81', 'number' => '10'), array('area' => '82', 'number' => '9'), array('area' => '82', 'number' => '10'), array('area' => '84', 'number' => '9'), array('area' => '84', 'number' => '10'), array('area' => '86', 'number' => '11'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '90', 'number' => '10'), array('area' => '91', 'number' => '10'), array('area' => '92', 'number' => '10'), array('area' => '93', 'number' => '9'), array('area' => '94', 'number' => '9'), array('area' => '95', 'number' => '8'), array('area' => '98', 'number' => '10'), array('area' => '212', 'number' => '9'), array('area' => '213', 'number' => '9'), array('area' => '216', 'number' => '8'), array('area' => '218', 'number' => '9'), array('area' => '220', 'number' => '7'), array('area' => '221', 'number' => '9'), array('area' => '222', 'number' => '7'), array('area' => '222', 'number' => '7'), array('area' => '223', 'number' => '8'), array('area' => '224', 'number' => '8'), array('area' => '225', 'number' => '8'), array('area' => '226', 'number' => '8'), array('area' => '227', 'number' => '8'), array('area' => '228', 'number' => '7'), array('area' => '229', 'number' => '8'), array('area' => '230', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '7'), array('area' => '231', 'number' => '8'), array('area' => '232', 'number' => '8'), array('area' => '233', 'number' => '8'), array('area' => '233', 'number' => '9'), array('area' => '234', 'number' => '8'), array('area' => '234', 'number' => '10'), array('area' => '235', 'number' => '7'), array('area' => '236', 'number' => '8'), array('area' => '236', 'number' => '8'), array('area' => '237', 'number' => '8'), array('area' => '238', 'number' => '7'), array('area' => '239', 'number' => '6'), array('area' => '240', 'number' => '6'), array('area' => '241', 'number' => '8'), array('area' => '242', 'number' => '7'), array('area' => '243', 'number' => '9'), array('area' => '243', 'number' => '9'), array('area' => '244', 'number' => '9'), array('area' => '245', 'number' => '7'), array('area' => '248', 'number' => '6'), array('area' => '248', 'number' => '7'), array('area' => '249', 'number' => '9'), array('area' => '250', 'number' => '9'), array('area' => '251', 'number' => '9'), array('area' => '252', 'number' => '7'), array('area' => '252', 'number' => '7'), array('area' => '253', 'number' => '6'), array('area' => '254', 'number' => '9'), array('area' => '255', 'number' => '9'), array('area' => '256', 'number' => '9'), array('area' => '257', 'number' => '8'), array('area' => '258', 'number' => '9'), array('area' => '260', 'number' => '8'), array('area' => '261', 'number' => '9'), array('area' => '262', 'number' => '9'), array('area' => '263', 'number' => '6'), array('area' => '263', 'number' => '7'), array('area' => '263', 'number' => '8'), array('area' => '263', 'number' => '9'), array('area' => '263', 'number' => '10'), array('area' => '264', 'number' => '9'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '7'), array('area' => '265', 'number' => '9'), array('area' => '266', 'number' => '8'), array('area' => '267', 'number' => '8'), array('area' => '268', 'number' => '7'), array('area' => '269', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '291', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '297', 'number' => '7'), array('area' => '298', 'number' => '6'), array('area' => '299', 'number' => '6'), array('area' => '350', 'number' => '8'), array('area' => '351', 'number' => '9'), array('area' => '352', 'number' => '9'), array('area' => '352', 'number' => '10'), array('area' => '353', 'number' => '9'), array('area' => '353', 'number' => '10'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '7'), array('area' => '354', 'number' => '9'), array('area' => '355', 'number' => '9'), array('area' => '356', 'number' => '8'), array('area' => '357', 'number' => '8'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '6'), array('area' => '358', 'number' => '8'), array('area' => '358', 'number' => '9'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '10'), array('area' => '358', 'number' => '11'), array('area' => '359', 'number' => '8'), array('area' => '359', 'number' => '9'), array('area' => '370', 'number' => '8'), array('area' => '370', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '371', 'number' => '8'), array('area' => '372', 'number' => '8'), array('area' => '373', 'number' => '8'), array('area' => '374', 'number' => '8'), array('area' => '375', 'number' => '9'), array('area' => '375', 'number' => '9'), array('area' => '376', 'number' => '6'), array('area' => '377', 'number' => '8'), array('area' => '377', 'number' => '9'), array('area' => '378', 'number' => '9'), array('area' => '378', 'number' => '10'), array('area' => '378', 'number' => '11'), array('area' => '378', 'number' => '12'), array('area' => '378', 'number' => '13'), array('area' => '380', 'number' => '9'), array('area' => '381', 'number' => '8'), array('area' => '381', 'number' => '9'), array('area' => '382', 'number' => '7'), array('area' => '382', 'number' => '8'), array('area' => '382', 'number' => '9'), array('area' => '382', 'number' => '10'), array('area' => '385', 'number' => '8'), array('area' => '385', 'number' => '9'), array('area' => '386', 'number' => '8'), array('area' => '387', 'number' => '8'), array('area' => '389', 'number' => '8'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '420', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '421', 'number' => '9'), array('area' => '423', 'number' => '7'), array('area' => '423', 'number' => '9'), array('area' => '500', 'number' => '5'), array('area' => '501', 'number' => '7'), array('area' => '502', 'number' => '8'), array('area' => '503', 'number' => '8'), array('area' => '504', 'number' => '8'), array('area' => '505', 'number' => '8'), array('area' => '506', 'number' => '8'), array('area' => '507', 'number' => '8'), array('area' => '508', 'number' => '6'), array('area' => '509', 'number' => '8'), array('area' => '590', 'number' => '9'), array('area' => '594', 'number' => '9'), array('area' => '591', 'number' => '8'), array('area' => '592', 'number' => '7'), array('area' => '593', 'number' => '8'), array('area' => '595', 'number' => '9'), array('area' => '596', 'number' => '9'), array('area' => '597', 'number' => '7'), array('area' => '598', 'number' => '8'), array('area' => '599', 'number' => '7'), array('area' => '599', 'number' => '8'), array('area' => '673', 'number' => '7'), array('area' => '674', 'number' => '7'), array('area' => '675', 'number' => '8'), array('area' => '676', 'number' => '5'), array('area' => '676', 'number' => '7'), array('area' => '677', 'number' => '5'), array('area' => '677', 'number' => '7'), array('area' => '678', 'number' => '7'), array('area' => '679', 'number' => '7'), array('area' => '680', 'number' => '7'), array('area' => '682', 'number' => '5'), array('area' => '685', 'number' => '7'), array('area' => '686', 'number' => '5'), array('area' => '686', 'number' => '5'), array('area' => '687', 'number' => '6'), array('area' => '688', 'number' => '5'), array('area' => '852', 'number' => '7'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '8'), array('area' => '852', 'number' => '12'), array('area' => '853', 'number' => '8'), array('area' => '855', 'number' => '8'), array('area' => '856', 'number' => '9'), array('area' => '880', 'number' => '10'), array('area' => '886', 'number' => '8'), array('area' => '886', 'number' => '9'), array('area' => '960', 'number' => '7'), array('area' => '961', 'number' => '7'), array('area' => '962', 'number' => '9'), array('area' => '963', 'number' => '9'), array('area' => '964', 'number' => '10'), array('area' => '965', 'number' => '8'), array('area' => '966', 'number' => '9'), array('area' => '967', 'number' => '9'), array('area' => '968', 'number' => '8'), array('area' => '971', 'number' => '9'), array('area' => '972', 'number' => '9'), array('area' => '973', 'number' => '8'), array('area' => '973', 'number' => '8'), array('area' => '974', 'number' => '7'), array('area' => '974', 'number' => '7'), array('area' => '975', 'number' => '8'), array('area' => '976', 'number' => '8'), array('area' => '977', 'number' => '9'), array('area' => '992', 'number' => '9'), array('area' => '993', 'number' => '8'), array('area' => '994', 'number' => '9'), array('area' => '995', 'number' => '8'), array('area' => '995', 'number' => '9'), array('area' => '996', 'number' => '9'), array('area' => '998', 'number' => '9'), array('area' => '58', 'number' => '8'));
    static public $isoToCallPrefix = array("DE" => "49", "AT" => "43", "BE" => "32", "CA" => "1", "CN" => "86", "ES" => "34", "FI" => "358", "FR" => "33", "GR" => "30", "IT" => "39", "JP" => "81", "LU" => "352", "NL" => "31", "PL" => "48", "PT" => "351", "CZ" => "420", "GB" => "44", "SE" => "46", "CH" => "41", "DK" => "45", "US" => "1", "HK" => "852", "NO" => "47", "AU" => "61", "SG" => "65", "IE" => "353", "NZ" => "64", "KR" => "82", "IL" => "972", "ZA" => "27", "NG" => "234", "CI" => "225", "TG" => "228", "BO" => "591", "MU" => "230", "RO" => "40", "SK" => "421", "DZ" => "213", "AS" => "0", "AD" => "376", "AO" => "244", "AI" => "0", "AG" => "0", "AR" => "54", "AM" => "374", "AW" => "297", "AZ" => "994", "BS" => "0", "BH" => "973", "BD" => "880", "BB" => "0", "BY" => "0", "BZ" => "501", "BJ" => "229", "BM" => "0", "BT" => "975", "BW" => "267", "BR" => "55", "BN" => "673", "BF" => "226", "MM" => "95", "BI" => "257", "KH" => "855", "CM" => "237", "CV" => "238", "CF" => "236", "TD" => "235", "CL" => "56", "CO" => "57", "KM" => "269", "CD" => "242", "CG" => "243", "CR" => "506", "HR" => "385", "CU" => "53", "CY" => "357", "DJ" => "253", "DM" => "0", "DO" => "0", "TL" => "670", "EC" => "593", "EG" => "20", "SV" => "503", "GQ" => "240", "ER" => "291", "EE" => "372", "ET" => "251", "FK" => "0", "FO" => "298", "FJ" => "679", "GA" => "241", "GM" => "220", "GE" => "995", "GH" => "233", "GD" => "0", "GL" => "299", "GI" => "350", "GP" => "590", "GU" => "0", "GT" => "502", "GG" => "0", "GN" => "224", "GW" => "245", "GY" => "592", "HT" => "509", "HM" => "0", "VA" => "379", "HN" => "504", "IS" => "354", "IN" => "91", "ID" => "62", "IR" => "98", "IQ" => "964", "IM" => "0", "JM" => "0", "JE" => "0", "JO" => "962", "KZ" => "7", "KE" => "254", "KI" => "686", "KP" => "850", "KW" => "965", "KG" => "996", "LA" => "856", "LV" => "371", "LB" => "961", "LS" => "266", "LR" => "231", "LY" => "218", "LI" => "423", "LT" => "370", "MO" => "853", "MK" => "389", "MG" => "261", "MW" => "265", "MY" => "60", "MV" => "960", "ML" => "223", "MT" => "356", "MH" => "692", "MQ" => "596", "MR" => "222", "HU" => "36", "YT" => "262", "MX" => "52", "FM" => "691", "MD" => "373", "MC" => "377", "MN" => "976", "ME" => "382", "MS" => "0", "MA" => "212", "MZ" => "258", "NA" => "264", "NR" => "674", "NP" => "977", "AN" => "599", "NC" => "687", "NI" => "505", "NE" => "227", "NU" => "683", "NF" => "0", "MP" => "0", "OM" => "968", "PK" => "92", "PW" => "680", "PS" => "0", "PA" => "507", "PG" => "675", "PY" => "595", "PE" => "51", "PH" => "63", "PN" => "0", "PR" => "0", "QA" => "974", "RE" => "262", "RU" => "7", "RW" => "250", "BL" => "0", "KN" => "0", "LC" => "0", "MF" => "0", "PM" => "508", "VC" => "0", "WS" => "685", "SM" => "378", "ST" => "239", "SA" => "966", "SN" => "221", "RS" => "381", "SC" => "248", "SL" => "232", "SI" => "386", "SB" => "677", "SO" => "252", "GS" => "0", "LK" => "94", "SD" => "249", "SR" => "597", "SJ" => "0", "SZ" => "268", "SY" => "963", "TW" => "886", "TJ" => "992", "TZ" => "255", "TH" => "66", "TK" => "690", "TO" => "676", "TT" => "0", "TN" => "216", "TR" => "90", "TM" => "993", "TC" => "0", "TV" => "688", "UG" => "256", "UA" => "380", "AE" => "971", "UY" => "598", "UZ" => "998", "VU" => "678", "VE" => "58", "VN" => "84", "VG" => "0", "VI" => "0", "WF" => "681", "EH" => "0", "YE" => "967", "ZM" => "260", "ZW" => "263", "AL" => "355", "AF" => "93", "AQ" => "0", "BA" => "387", "BV" => "0", "IO" => "0", "BG" => "359", "KY" => "0", "CX" => "0", "CC" => "0", "CK" => "682", "GF" => "594", "PF" => "689", "TF" => "0", "AX" => "0", "DE" => "49", "AT" => "43", "BE" => "32", "CA" => "1", "CN" => "86", "ES" => "34", "FI" => "358", "FR" => "33", "GR" => "30", "IT" => "39", "JP" => "81", "LU" => "352", "NL" => "31", "PL" => "48", "PT" => "351", "CZ" => "420", "GB" => "44", "SE" => "46", "CH" => "41", "DK" => "45", "US" => "1", "HK" => "852", "NO" => "47", "AU" => "61", "SG" => "65", "IE" => "353", "NZ" => "64", "KR" => "82", "IL" => "972", "ZA" => "27", "NG" => "234", "CI" => "225", "TG" => "228", "BO" => "591", "MU" => "230", "RO" => "40", "SK" => "421", "DZ" => "213", "AS" => "0", "AD" => "376", "AO" => "244", "AI" => "0", "AG" => "0", "AR" => "54", "AM" => "374", "AW" => "297", "AZ" => "994", "BS" => "0", "BH" => "973", "BD" => "880", "BB" => "0", "BY" => "0", "BZ" => "501", "BJ" => "229", "BM" => "0", "BT" => "975", "BW" => "267", "BR" => "55", "BN" => "673", "BF" => "226", "MM" => "95", "BI" => "257", "KH" => "855", "CM" => "237", "CV" => "238", "CF" => "236", "TD" => "235", "CL" => "56", "CO" => "57", "KM" => "269", "CD" => "242", "CG" => "243", "CR" => "506", "HR" => "385", "CU" => "53", "CY" => "357", "DJ" => "253", "DM" => "0", "DO" => "0", "TL" => "670", "EC" => "593", "EG" => "20", "SV" => "503", "GQ" => "240", "ER" => "291", "EE" => "372", "ET" => "251", "FK" => "0", "FO" => "298", "FJ" => "679", "GA" => "241", "GM" => "220", "GE" => "995", "GH" => "233", "GD" => "0", "GL" => "299", "GI" => "350", "GP" => "590", "GU" => "0", "GT" => "502", "GG" => "0", "GN" => "224", "GW" => "245", "GY" => "592", "HT" => "509", "HM" => "0", "VA" => "379", "HN" => "504", "IS" => "354", "IN" => "91", "ID" => "62", "IR" => "98", "IQ" => "964", "IM" => "0", "JM" => "0", "JE" => "0", "JO" => "962", "KZ" => "7", "KE" => "254", "KI" => "686", "KP" => "850", "KW" => "965", "KG" => "996", "LA" => "856", "LV" => "371", "LB" => "961", "LS" => "266", "LR" => "231", "LY" => "218", "LI" => "423", "LT" => "370", "MO" => "853", "MK" => "389", "MG" => "261", "MW" => "265", "MY" => "60", "MV" => "960", "ML" => "223", "MT" => "356", "MH" => "692", "MQ" => "596", "MR" => "222", "HU" => "36", "YT" => "262", "MX" => "52", "FM" => "691", "MD" => "373", "MC" => "377", "MN" => "976", "ME" => "382", "MS" => "0", "MA" => "212", "MZ" => "258", "NA" => "264", "NR" => "674", "NP" => "977", "AN" => "599", "NC" => "687", "NI" => "505", "NE" => "227", "NU" => "683", "NF" => "0", "MP" => "0", "OM" => "968", "PK" => "92", "PW" => "680", "PS" => "0", "PA" => "507", "PG" => "675", "PY" => "595", "PE" => "51", "PH" => "63", "PN" => "0", "PR" => "0", "QA" => "974", "RE" => "262", "RU" => "7", "RW" => "250", "BL" => "0", "KN" => "0", "LC" => "0", "MF" => "0", "PM" => "508", "VC" => "0", "WS" => "685", "SM" => "378", "ST" => "239", "SA" => "966", "SN" => "221", "RS" => "381", "SC" => "248", "SL" => "232", "SI" => "386", "SB" => "677", "SO" => "252", "GS" => "0", "LK" => "94", "SD" => "249", "SR" => "597", "SJ" => "0", "SZ" => "268", "SY" => "963", "TW" => "886", "TJ" => "992", "TZ" => "255", "TH" => "66", "TK" => "690", "TO" => "676", "TT" => "0", "TN" => "216", "TR" => "90", "TM" => "993", "TC" => "0", "TV" => "688", "UG" => "256", "UA" => "380", "AE" => "971", "UY" => "598", "UZ" => "998", "VU" => "678", "VE" => "58", "VN" => "84", "VG" => "0", "VI" => "0", "WF" => "681", "EH" => "0", "YE" => "967", "ZM" => "260", "ZW" => "263", "AL" => "355", "AF" => "93", "AQ" => "0", "BA" => "387", "BV" => "0", "IO" => "0", "BG" => "359", "KY" => "0", "CX" => "0", "CC" => "0", "CK" => "682", "GF" => "594", "PF" => "689", "TF" => "0", "AX" => "0", "DE" => "49", "AT" => "43", "BE" => "32", "CA" => "1", "CN" => "86", "ES" => "34", "FI" => "358", "FR" => "33", "GR" => "30", "IT" => "39", "JP" => "81", "LU" => "352", "NL" => "31", "PL" => "48", "PT" => "351", "CZ" => "420", "GB" => "44", "SE" => "46", "CH" => "41", "DK" => "45", "US" => "1", "HK" => "852", "NO" => "47", "AU" => "61", "SG" => "65", "IE" => "353", "NZ" => "64", "KR" => "82", "IL" => "972", "ZA" => "27", "NG" => "234", "CI" => "225", "TG" => "228", "BO" => "591", "MU" => "230", "RO" => "40", "SK" => "421", "DZ" => "213", "AS" => "0", "AD" => "376", "AO" => "244", "AI" => "0", "AG" => "0", "AR" => "54", "AM" => "374", "AW" => "297", "AZ" => "994", "BS" => "0", "BH" => "973", "BD" => "880", "BB" => "0", "BY" => "0", "BZ" => "501", "BJ" => "229", "BM" => "0", "BT" => "975", "BW" => "267", "BR" => "55", "BN" => "673", "BF" => "226", "MM" => "95", "BI" => "257", "KH" => "855", "CM" => "237", "CV" => "238", "CF" => "236", "TD" => "235", "CL" => "56", "CO" => "57", "KM" => "269", "CD" => "242", "CG" => "243", "CR" => "506", "HR" => "385", "CU" => "53", "CY" => "357", "DJ" => "253", "DM" => "0", "DO" => "0", "TL" => "670", "EC" => "593", "EG" => "20", "SV" => "503", "GQ" => "240", "ER" => "291", "EE" => "372", "ET" => "251", "FK" => "0", "FO" => "298", "FJ" => "679", "GA" => "241", "GM" => "220", "GE" => "995", "GH" => "233", "GD" => "0", "GL" => "299", "GI" => "350", "GP" => "590", "GU" => "0", "GT" => "502", "GG" => "0", "GN" => "224", "GW" => "245", "GY" => "592", "HT" => "509", "HM" => "0", "VA" => "379", "HN" => "504", "IS" => "354", "IN" => "91", "ID" => "62", "IR" => "98", "IQ" => "964", "IM" => "0", "JM" => "0", "JE" => "0", "JO" => "962", "KZ" => "7", "KE" => "254", "KI" => "686", "KP" => "850", "KW" => "965", "KG" => "996", "LA" => "856", "LV" => "371", "LB" => "961", "LS" => "266", "LR" => "231", "LY" => "218", "LI" => "423", "LT" => "370", "MO" => "853", "MK" => "389", "MG" => "261", "MW" => "265", "MY" => "60", "MV" => "960", "ML" => "223", "MT" => "356", "MH" => "692", "MQ" => "596", "MR" => "222", "HU" => "36", "YT" => "262", "MX" => "52", "FM" => "691", "MD" => "373", "MC" => "377", "MN" => "976", "ME" => "382", "MS" => "0", "MA" => "212", "MZ" => "258", "NA" => "264", "NR" => "674", "NP" => "977", "AN" => "599", "NC" => "687", "NI" => "505", "NE" => "227", "NU" => "683", "NF" => "0", "MP" => "0", "OM" => "968", "PK" => "92", "PW" => "680", "PS" => "0", "PA" => "507", "PG" => "675", "PY" => "595", "PE" => "51", "PH" => "63", "PN" => "0", "PR" => "0", "QA" => "974", "RE" => "262", "RU" => "7", "RW" => "250", "BL" => "0", "KN" => "0", "LC" => "0", "MF" => "0", "PM" => "508", "VC" => "0", "WS" => "685", "SM" => "378", "ST" => "239", "SA" => "966", "SN" => "221", "RS" => "381", "SC" => "248", "SL" => "232", "SI" => "386", "SB" => "677", "SO" => "252", "GS" => "0", "LK" => "94", "SD" => "249", "SR" => "597", "SJ" => "0", "SZ" => "268", "SY" => "963", "TW" => "886", "TJ" => "992", "TZ" => "255", "TH" => "66", "TK" => "690", "TO" => "676", "TT" => "0", "TN" => "216", "TR" => "90", "TM" => "993", "TC" => "0", "TV" => "688", "UG" => "256", "UA" => "380", "AE" => "971", "UY" => "598", "UZ" => "998", "VU" => "678", "VE" => "58", "VN" => "84", "VG" => "0", "VI" => "0", "WF" => "681", "EH" => "0", "YE" => "967", "ZM" => "260", "ZW" => "263", "AL" => "355", "AF" => "93", "AQ" => "0", "BA" => "387", "BV" => "0", "IO" => "0", "BG" => "359", "KY" => "0", "CX" => "0", "CC" => "0", "CK" => "682", "GF" => "594", "PF" => "689", "TF" => "0", "AX" => "0", "DE" => "49", "AT" => "43", "BE" => "32", "CA" => "1", "CN" => "86", "ES" => "34", "FI" => "358", "FR" => "33", "GR" => "30", "IT" => "39", "JP" => "81", "LU" => "352", "NL" => "31", "PL" => "48", "PT" => "351", "CZ" => "420", "GB" => "44", "SE" => "46", "CH" => "41", "DK" => "45", "US" => "1", "HK" => "852", "NO" => "47", "AU" => "61", "SG" => "65", "IE" => "353", "NZ" => "64", "KR" => "82", "IL" => "972", "ZA" => "27", "NG" => "234", "CI" => "225", "TG" => "228", "BO" => "591", "MU" => "230", "RO" => "40", "SK" => "421", "DZ" => "213", "AS" => "0", "AD" => "376", "AO" => "244", "AI" => "0", "AG" => "0", "AR" => "54", "AM" => "374", "AW" => "297", "AZ" => "994", "BS" => "0", "BH" => "973", "BD" => "880", "BB" => "0", "BY" => "0", "BZ" => "501", "BJ" => "229", "BM" => "0", "BT" => "975", "BW" => "267", "BR" => "55", "BN" => "673", "BF" => "226", "MM" => "95", "BI" => "257", "KH" => "855", "CM" => "237", "CV" => "238", "CF" => "236", "TD" => "235", "CL" => "56", "CO" => "57", "KM" => "269", "CD" => "242", "CG" => "243", "CR" => "506", "HR" => "385", "CU" => "53", "CY" => "357", "DJ" => "253", "DM" => "0", "DO" => "0", "TL" => "670", "EC" => "593", "EG" => "20", "SV" => "503", "GQ" => "240", "ER" => "291", "EE" => "372", "ET" => "251", "FK" => "0", "FO" => "298", "FJ" => "679", "GA" => "241", "GM" => "220", "GE" => "995", "GH" => "233", "GD" => "0", "GL" => "299", "GI" => "350", "GP" => "590", "GU" => "0", "GT" => "502", "GG" => "0", "GN" => "224", "GW" => "245", "GY" => "592", "HT" => "509", "HM" => "0", "VA" => "379", "HN" => "504", "IS" => "354", "IN" => "91", "ID" => "62", "IR" => "98", "IQ" => "964", "IM" => "0", "JM" => "0", "JE" => "0", "JO" => "962", "KZ" => "7", "KE" => "254", "KI" => "686", "KP" => "850", "KW" => "965", "KG" => "996", "LA" => "856", "LV" => "371", "LB" => "961", "LS" => "266", "LR" => "231", "LY" => "218", "LI" => "423", "LT" => "370", "MO" => "853", "MK" => "389", "MG" => "261", "MW" => "265", "MY" => "60", "MV" => "960", "ML" => "223", "MT" => "356", "MH" => "692", "MQ" => "596", "MR" => "222", "HU" => "36", "YT" => "262", "MX" => "52", "FM" => "691", "MD" => "373", "MC" => "377", "MN" => "976", "ME" => "382", "MS" => "0", "MA" => "212", "MZ" => "258", "NA" => "264", "NR" => "674", "NP" => "977", "AN" => "599", "NC" => "687", "NI" => "505", "NE" => "227", "NU" => "683", "NF" => "0", "MP" => "0", "OM" => "968", "PK" => "92", "PW" => "680", "PS" => "0", "PA" => "507", "PG" => "675", "PY" => "595", "PE" => "51", "PH" => "63", "PN" => "0", "PR" => "0", "QA" => "974", "RE" => "262", "RU" => "7", "RW" => "250", "BL" => "0", "KN" => "0", "LC" => "0", "MF" => "0", "PM" => "508", "VC" => "0", "WS" => "685", "SM" => "378", "ST" => "239", "SA" => "966", "SN" => "221", "RS" => "381", "SC" => "248", "SL" => "232", "SI" => "386", "SB" => "677", "SO" => "252", "GS" => "0", "LK" => "94", "SD" => "249", "SR" => "597", "SJ" => "0", "SZ" => "268", "SY" => "963", "TW" => "886", "TJ" => "992", "TZ" => "255", "TH" => "66", "TK" => "690", "TO" => "676", "TT" => "0", "TN" => "216", "TR" => "90", "TM" => "993", "TC" => "0", "TV" => "688", "UG" => "256", "UA" => "380", "AE" => "971", "UY" => "598", "UZ" => "998", "VU" => "678", "VE" => "58", "VN" => "84", "VG" => "0", "VI" => "0", "WF" => "681", "EH" => "0", "YE" => "967", "ZM" => "260", "ZW" => "263", "AL" => "355", "AF" => "93", "AQ" => "0", "BA" => "387", "BV" => "0", "IO" => "0", "BG" => "359", "KY" => "0", "CX" => "0", "CC" => "0", "CK" => "682", "GF" => "594", "PF" => "689", "TF" => "0", "AX" => "0", "DE" => "49", "AT" => "43", "BE" => "32", "CA" => "1", "CN" => "86", "ES" => "34", "FI" => "358", "FR" => "33", "GR" => "30", "IT" => "39", "JP" => "81", "LU" => "352", "NL" => "31", "PL" => "48", "PT" => "351", "CZ" => "420", "GB" => "44", "SE" => "46", "CH" => "41", "DK" => "45", "US" => "1", "HK" => "852", "NO" => "47", "AU" => "61", "SG" => "65", "IE" => "353", "NZ" => "64", "KR" => "82", "IL" => "972", "ZA" => "27", "NG" => "234", "CI" => "225", "TG" => "228", "BO" => "591", "MU" => "230", "RO" => "40", "SK" => "421", "DZ" => "213", "AS" => "0", "AD" => "376", "AO" => "244", "AI" => "0", "AG" => "0", "AR" => "54", "AM" => "374", "AW" => "297", "AZ" => "994", "BS" => "0", "BH" => "973", "BD" => "880", "BB" => "0", "BY" => "0", "BZ" => "501", "BJ" => "229", "BM" => "0", "BT" => "975", "BW" => "267", "BR" => "55", "BN" => "673", "BF" => "226", "MM" => "95", "BI" => "257", "KH" => "855", "CM" => "237", "CV" => "238", "CF" => "236", "TD" => "235", "CL" => "56", "CO" => "57", "KM" => "269", "CD" => "242", "CG" => "243", "CR" => "506", "HR" => "385", "CU" => "53", "CY" => "357", "DJ" => "253", "DM" => "0", "DO" => "0", "TL" => "670", "EC" => "593", "EG" => "20", "SV" => "503", "GQ" => "240", "ER" => "291", "EE" => "372", "ET" => "251", "FK" => "0", "FO" => "298", "FJ" => "679", "GA" => "241", "GM" => "220", "GE" => "995", "GH" => "233", "GD" => "0", "GL" => "299", "GI" => "350", "GP" => "590", "GU" => "0", "GT" => "502", "GG" => "0", "GN" => "224", "GW" => "245", "GY" => "592", "HT" => "509", "HM" => "0", "VA" => "379", "HN" => "504", "IS" => "354", "IN" => "91", "ID" => "62", "IR" => "98", "IQ" => "964", "IM" => "0", "JM" => "0", "JE" => "0", "JO" => "962", "KZ" => "7", "KE" => "254", "KI" => "686", "KP" => "850", "KW" => "965", "KG" => "996", "LA" => "856", "LV" => "371", "LB" => "961", "LS" => "266", "LR" => "231", "LY" => "218", "LI" => "423", "LT" => "370", "MO" => "853", "MK" => "389", "MG" => "261", "MW" => "265", "MY" => "60", "MV" => "960", "ML" => "223", "MT" => "356", "MH" => "692", "MQ" => "596", "MR" => "222", "HU" => "36", "YT" => "262", "MX" => "52", "FM" => "691", "MD" => "373", "MC" => "377", "MN" => "976", "ME" => "382", "MS" => "0", "MA" => "212", "MZ" => "258", "NA" => "264", "NR" => "674", "NP" => "977", "AN" => "599", "NC" => "687", "NI" => "505", "NE" => "227", "NU" => "683", "NF" => "0", "MP" => "0", "OM" => "968", "PK" => "92", "PW" => "680", "PS" => "0", "PA" => "507", "PG" => "675", "PY" => "595", "PE" => "51", "PH" => "63", "PN" => "0", "PR" => "0", "QA" => "974", "RE" => "262", "RU" => "7", "RW" => "250", "BL" => "0", "KN" => "0", "LC" => "0", "MF" => "0", "PM" => "508", "VC" => "0", "WS" => "685", "SM" => "378", "ST" => "239", "SA" => "966", "SN" => "221", "RS" => "381", "SC" => "248", "SL" => "232", "SI" => "386", "SB" => "677", "SO" => "252", "GS" => "0", "LK" => "94", "SD" => "249", "SR" => "597", "SJ" => "0", "SZ" => "268", "SY" => "963", "TW" => "886", "TJ" => "992", "TZ" => "255", "TH" => "66", "TK" => "690", "TO" => "676", "TT" => "0", "TN" => "216", "TR" => "90", "TM" => "993", "TC" => "0", "TV" => "688", "UG" => "256", "UA" => "380", "AE" => "971", "UY" => "598", "UZ" => "998", "VU" => "678", "VE" => "58", "VN" => "84", "VG" => "0", "VI" => "0", "WF" => "681", "EH" => "0", "YE" => "967", "ZM" => "260", "ZW" => "263", "AL" => "355", "AF" => "93", "AQ" => "0", "BA" => "387", "BV" => "0", "IO" => "0", "BG" => "359", "KY" => "0", "CX" => "0", "CC" => "0", "CK" => "682", "GF" => "594", "PF" => "689", "TF" => "0", "AX" => "0", "DE" => "49", "AT" => "43", "BE" => "32", "CA" => "1", "CN" => "86", "ES" => "34", "FI" => "358", "FR" => "33", "GR" => "30", "IT" => "39", "JP" => "81", "LU" => "352", "NL" => "31", "PL" => "48", "PT" => "351", "CZ" => "420", "GB" => "44", "SE" => "46", "CH" => "41", "DK" => "45", "US" => "1", "HK" => "852", "NO" => "47", "AU" => "61", "SG" => "65", "IE" => "353", "NZ" => "64", "KR" => "82", "IL" => "972", "ZA" => "27", "NG" => "234", "CI" => "225", "TG" => "228", "BO" => "591", "MU" => "230", "RO" => "40", "SK" => "421", "DZ" => "213", "AS" => "0", "AD" => "376", "AO" => "244", "AI" => "0", "AG" => "0", "AR" => "54", "AM" => "374", "AW" => "297", "AZ" => "994", "BS" => "0", "BH" => "973", "BD" => "880", "BB" => "0", "BY" => "0", "BZ" => "501", "BJ" => "229", "BM" => "0", "BT" => "975", "BW" => "267", "BR" => "55", "BN" => "673", "BF" => "226", "MM" => "95", "BI" => "257", "KH" => "855", "CM" => "237", "CV" => "238", "CF" => "236", "TD" => "235", "CL" => "56", "CO" => "57", "KM" => "269", "CD" => "242", "CG" => "243", "CR" => "506", "HR" => "385", "CU" => "53", "CY" => "357", "DJ" => "253", "DM" => "0", "DO" => "0", "TL" => "670", "EC" => "593", "EG" => "20", "SV" => "503", "GQ" => "240", "ER" => "291", "EE" => "372", "ET" => "251", "FK" => "0", "FO" => "298", "FJ" => "679", "GA" => "241", "GM" => "220", "GE" => "995", "GH" => "233", "GD" => "0", "GL" => "299", "GI" => "350", "GP" => "590", "GU" => "0", "GT" => "502", "GG" => "0", "GN" => "224", "GW" => "245", "GY" => "592", "HT" => "509", "HM" => "0", "VA" => "379", "HN" => "504", "IS" => "354", "IN" => "91", "ID" => "62", "IR" => "98", "IQ" => "964", "IM" => "0", "JM" => "0", "JE" => "0", "JO" => "962", "KZ" => "7", "KE" => "254", "KI" => "686", "KP" => "850", "KW" => "965", "KG" => "996", "LA" => "856", "LV" => "371", "LB" => "961", "LS" => "266", "LR" => "231", "LY" => "218", "LI" => "423", "LT" => "370", "MO" => "853", "MK" => "389", "MG" => "261", "MW" => "265", "MY" => "60", "MV" => "960", "ML" => "223", "MT" => "356", "MH" => "692", "MQ" => "596", "MR" => "222", "HU" => "36", "YT" => "262", "MX" => "52", "FM" => "691", "MD" => "373", "MC" => "377", "MN" => "976", "ME" => "382", "MS" => "0", "MA" => "212", "MZ" => "258", "NA" => "264", "NR" => "674", "NP" => "977", "AN" => "599", "NC" => "687", "NI" => "505", "NE" => "227", "NU" => "683", "NF" => "0", "MP" => "0", "OM" => "968", "PK" => "92", "PW" => "680", "PS" => "0", "PA" => "507", "PG" => "675", "PY" => "595", "PE" => "51", "PH" => "63", "PN" => "0", "PR" => "0", "QA" => "974", "RE" => "262", "RU" => "7", "RW" => "250", "BL" => "0", "KN" => "0", "LC" => "0", "MF" => "0", "PM" => "508", "VC" => "0", "WS" => "685", "SM" => "378", "ST" => "239", "SA" => "966", "SN" => "221", "RS" => "381", "SC" => "248", "SL" => "232", "SI" => "386", "SB" => "677", "SO" => "252", "GS" => "0", "LK" => "94", "SD" => "249", "SR" => "597", "SJ" => "0", "SZ" => "268", "SY" => "963", "TW" => "886", "TJ" => "992", "TZ" => "255", "TH" => "66", "TK" => "690", "TO" => "676", "TT" => "0", "TN" => "216", "TR" => "90", "TM" => "993", "TC" => "0", "TV" => "688", "UG" => "256", "UA" => "380", "AE" => "971", "UY" => "598", "UZ" => "998", "VU" => "678", "VE" => "58", "VN" => "84", "VG" => "0", "VI" => "0", "WF" => "681", "EH" => "0", "YE" => "967", "ZM" => "260", "ZW" => "263", "AL" => "355", "AF" => "93", "AQ" => "0", "BA" => "387", "BV" => "0", "IO" => "0", "BG" => "359", "KY" => "0", "CX" => "0", "CC" => "0", "CK" => "682", "GF" => "594", "PF" => "689", "TF" => "0", "AX" => "0", "DE" => "49", "AT" => "43", "BE" => "32", "CA" => "1", "CN" => "86", "ES" => "34", "FI" => "358", "FR" => "33", "GR" => "30", "IT" => "39", "JP" => "81", "LU" => "352", "NL" => "31", "PL" => "48", "PT" => "351", "CZ" => "420", "GB" => "44", "SE" => "46", "CH" => "41", "DK" => "45", "US" => "1", "HK" => "852", "NO" => "47", "AU" => "61", "SG" => "65", "IE" => "353", "NZ" => "64", "KR" => "82", "IL" => "972", "ZA" => "27", "NG" => "234", "CI" => "225", "TG" => "228", "BO" => "591", "MU" => "230", "RO" => "40", "SK" => "421", "DZ" => "213", "AS" => "0", "AD" => "376", "AO" => "244", "AI" => "0", "AG" => "0", "AR" => "54", "AM" => "374", "AW" => "297", "AZ" => "994", "BS" => "0", "BH" => "973", "BD" => "880", "BB" => "0", "BY" => "0", "BZ" => "501", "BJ" => "229", "BM" => "0", "BT" => "975", "BW" => "267", "BR" => "55", "BN" => "673", "BF" => "226", "MM" => "95", "BI" => "257", "KH" => "855", "CM" => "237", "CV" => "238", "CF" => "236", "TD" => "235", "CL" => "56", "CO" => "57", "KM" => "269", "CD" => "242", "CG" => "243", "CR" => "506", "HR" => "385", "CU" => "53", "CY" => "357", "DJ" => "253", "DM" => "0", "DO" => "0", "TL" => "670", "EC" => "593", "EG" => "20", "SV" => "503", "GQ" => "240", "ER" => "291", "EE" => "372", "ET" => "251", "FK" => "0", "FO" => "298", "FJ" => "679", "GA" => "241", "GM" => "220", "GE" => "995", "GH" => "233", "GD" => "0", "GL" => "299", "GI" => "350", "GP" => "590", "GU" => "0", "GT" => "502", "GG" => "0", "GN" => "224", "GW" => "245", "GY" => "592", "HT" => "509", "HM" => "0", "VA" => "379", "HN" => "504", "IS" => "354", "IN" => "91", "ID" => "62", "IR" => "98", "IQ" => "964", "IM" => "0", "JM" => "0", "JE" => "0", "JO" => "962", "KZ" => "7", "KE" => "254", "KI" => "686", "KP" => "850", "KW" => "965", "KG" => "996", "LA" => "856", "LV" => "371", "LB" => "961", "LS" => "266", "LR" => "231", "LY" => "218", "LI" => "423", "LT" => "370", "MO" => "853", "MK" => "389", "MG" => "261", "MW" => "265", "MY" => "60", "MV" => "960", "ML" => "223", "MT" => "356", "MH" => "692", "MQ" => "596", "MR" => "222", "HU" => "36", "YT" => "262", "MX" => "52", "FM" => "691", "MD" => "373", "MC" => "377", "MN" => "976", "ME" => "382", "MS" => "0", "MA" => "212", "MZ" => "258", "NA" => "264", "NR" => "674", "NP" => "977", "AN" => "599", "NC" => "687", "NI" => "505", "NE" => "227", "NU" => "683", "NF" => "0", "MP" => "0", "OM" => "968", "PK" => "92", "PW" => "680", "PS" => "0", "PA" => "507", "PG" => "675", "PY" => "595", "PE" => "51", "PH" => "63", "PN" => "0", "PR" => "0", "QA" => "974", "RE" => "262", "RU" => "7", "RW" => "250", "BL" => "0", "KN" => "0", "LC" => "0", "MF" => "0", "PM" => "508", "VC" => "0", "WS" => "685", "SM" => "378", "ST" => "239", "SA" => "966", "SN" => "221", "RS" => "381", "SC" => "248", "SL" => "232", "SI" => "386", "SB" => "677", "SO" => "252", "GS" => "0", "LK" => "94", "SD" => "249", "SR" => "597", "SJ" => "0", "SZ" => "268", "SY" => "963", "TW" => "886", "TJ" => "992", "TZ" => "255", "TH" => "66", "TK" => "690", "TO" => "676", "TT" => "0", "TN" => "216", "TR" => "90", "TM" => "993", "TC" => "0", "TV" => "688", "UG" => "256", "UA" => "380", "AE" => "971", "UY" => "598", "UZ" => "998", "VU" => "678", "VE" => "58", "VN" => "84", "VG" => "0", "VI" => "0", "WF" => "681", "EH" => "0", "YE" => "967", "ZM" => "260", "ZW" => "263", "AL" => "355", "AF" => "93", "AQ" => "0", "BA" => "387", "BV" => "0", "IO" => "0", "BG" => "359", "KY" => "0", "CX" => "0", "CC" => "0", "CK" => "682", "GF" => "594", "PF" => "689", "TF" => "0", "AX" => "0", "DE" => "49", "AT" => "43", "BE" => "32", "CA" => "1", "CN" => "86", "ES" => "34", "FI" => "358", "FR" => "33", "GR" => "30", "IT" => "39", "JP" => "81", "LU" => "352", "NL" => "31", "PL" => "48", "PT" => "351", "CZ" => "420", "GB" => "44", "SE" => "46", "CH" => "41", "DK" => "45", "US" => "1", "HK" => "852", "NO" => "47", "AU" => "61", "SG" => "65", "IE" => "353", "NZ" => "64", "KR" => "82", "IL" => "972", "ZA" => "27", "NG" => "234", "CI" => "225", "TG" => "228", "BO" => "591", "MU" => "230", "RO" => "40", "SK" => "421", "DZ" => "213", "AS" => "0", "AD" => "376", "AO" => "244", "AI" => "0", "AG" => "0", "AR" => "54", "AM" => "374", "AW" => "297", "AZ" => "994", "BS" => "0", "BH" => "973", "BD" => "880", "BB" => "0", "BY" => "0", "BZ" => "501", "BJ" => "229", "BM" => "0", "BT" => "975", "BW" => "267", "BR" => "55", "BN" => "673", "BF" => "226", "MM" => "95", "BI" => "257", "KH" => "855", "CM" => "237", "CV" => "238", "CF" => "236", "TD" => "235", "CL" => "56", "CO" => "57", "KM" => "269", "CD" => "242", "CG" => "243", "CR" => "506", "HR" => "385", "CU" => "53", "CY" => "357", "DJ" => "253", "DM" => "0", "DO" => "0", "TL" => "670", "EC" => "593", "EG" => "20", "SV" => "503", "GQ" => "240", "ER" => "291", "EE" => "372", "ET" => "251", "FK" => "0", "FO" => "298", "FJ" => "679", "GA" => "241", "GM" => "220", "GE" => "995", "GH" => "233", "GD" => "0", "GL" => "299", "GI" => "350", "GP" => "590", "GU" => "0", "GT" => "502", "GG" => "0", "GN" => "224", "GW" => "245", "GY" => "592", "HT" => "509", "HM" => "0", "VA" => "379", "HN" => "504", "IS" => "354", "IN" => "91", "ID" => "62", "IR" => "98", "IQ" => "964", "IM" => "0", "JM" => "0", "JE" => "0", "JO" => "962", "KZ" => "7", "KE" => "254", "KI" => "686", "KP" => "850", "KW" => "965", "KG" => "996", "LA" => "856", "LV" => "371", "LB" => "961", "LS" => "266", "LR" => "231", "LY" => "218", "LI" => "423", "LT" => "370", "MO" => "853", "MK" => "389", "MG" => "261", "MW" => "265", "MY" => "60", "MV" => "960", "ML" => "223", "MT" => "356", "MH" => "692", "MQ" => "596", "MR" => "222", "HU" => "36", "YT" => "262", "MX" => "52", "FM" => "691", "MD" => "373", "MC" => "377", "MN" => "976", "ME" => "382", "MS" => "0", "MA" => "212", "MZ" => "258", "NA" => "264", "NR" => "674", "NP" => "977", "AN" => "599", "NC" => "687", "NI" => "505", "NE" => "227", "NU" => "683", "NF" => "0", "MP" => "0", "OM" => "968", "PK" => "92", "PW" => "680", "PS" => "0", "PA" => "507", "PG" => "675", "PY" => "595", "PE" => "51", "PH" => "63", "PN" => "0", "PR" => "0", "QA" => "974", "RE" => "262", "RU" => "7", "RW" => "250", "BL" => "0", "KN" => "0", "LC" => "0", "MF" => "0", "PM" => "508", "VC" => "0", "WS" => "685", "SM" => "378", "ST" => "239", "SA" => "966", "SN" => "221", "RS" => "381", "SC" => "248", "SL" => "232", "SI" => "386", "SB" => "677", "SO" => "252", "GS" => "0", "LK" => "94", "SD" => "249", "SR" => "597", "SJ" => "0", "SZ" => "268", "SY" => "963", "TW" => "886", "TJ" => "992", "TZ" => "255", "TH" => "66", "TK" => "690", "TO" => "676", "TT" => "0", "TN" => "216", "TR" => "90", "TM" => "993", "TC" => "0", "TV" => "688", "UG" => "256", "UA" => "380", "AE" => "971", "UY" => "598", "UZ" => "998", "VU" => "678", "VE" => "58", "VN" => "84", "VG" => "0", "VI" => "0", "WF" => "681", "EH" => "0", "YE" => "967", "ZM" => "260", "ZW" => "263", "AL" => "355", "AF" => "93", "AQ" => "0", "BA" => "387", "BV" => "0", "IO" => "0", "BG" => "359", "KY" => "0", "CX" => "0", "CC" => "0", "CK" => "682", "GF" => "594", "PF" => "689", "TF" => "0", "AX" => "0", "DE" => "49", "AT" => "43", "BE" => "32", "CA" => "1", "CN" => "86", "ES" => "34", "FI" => "358", "FR" => "33", "GR" => "30", "IT" => "39", "JP" => "81", "LU" => "352", "NL" => "31", "PL" => "48", "PT" => "351", "CZ" => "420", "GB" => "44", "SE" => "46", "CH" => "41", "DK" => "45", "US" => "1", "HK" => "852", "NO" => "47", "AU" => "61", "SG" => "65", "IE" => "353", "NZ" => "64", "KR" => "82", "IL" => "972", "ZA" => "27", "NG" => "234", "CI" => "225", "TG" => "228", "BO" => "591", "MU" => "230", "RO" => "40", "SK" => "421", "DZ" => "213", "AS" => "0", "AD" => "376", "AO" => "244", "AI" => "0", "AG" => "0", "AR" => "54", "AM" => "374", "AW" => "297", "AZ" => "994", "BS" => "0", "BH" => "973", "BD" => "880", "BB" => "0", "BY" => "0", "BZ" => "501", "BJ" => "229", "BM" => "0", "BT" => "975", "BW" => "267", "BR" => "55", "BN" => "673", "BF" => "226", "MM" => "95", "BI" => "257", "KH" => "855", "CM" => "237", "CV" => "238", "CF" => "236", "TD" => "235", "CL" => "56", "CO" => "57", "KM" => "269", "CD" => "242", "CG" => "243", "CR" => "506", "HR" => "385", "CU" => "53", "CY" => "357", "DJ" => "253", "DM" => "0", "DO" => "0", "TL" => "670", "EC" => "593", "EG" => "20", "SV" => "503", "GQ" => "240", "ER" => "291", "EE" => "372", "ET" => "251", "FK" => "0", "FO" => "298", "FJ" => "679", "GA" => "241", "GM" => "220", "GE" => "995", "GH" => "233", "GD" => "0", "GL" => "299", "GI" => "350", "GP" => "590", "GU" => "0", "GT" => "502", "GG" => "0", "GN" => "224", "GW" => "245", "GY" => "592", "HT" => "509", "HM" => "0", "VA" => "379", "HN" => "504", "IS" => "354", "IN" => "91", "ID" => "62", "IR" => "98", "IQ" => "964", "IM" => "0", "JM" => "0", "JE" => "0", "JO" => "962", "KZ" => "7", "KE" => "254", "KI" => "686", "KP" => "850", "KW" => "965", "KG" => "996", "LA" => "856", "LV" => "371", "LB" => "961", "LS" => "266", "LR" => "231", "LY" => "218", "LI" => "423", "LT" => "370", "MO" => "853", "MK" => "389", "MG" => "261", "MW" => "265", "MY" => "60", "MV" => "960", "ML" => "223", "MT" => "356", "MH" => "692", "MQ" => "596", "MR" => "222", "HU" => "36", "YT" => "262", "MX" => "52", "FM" => "691", "MD" => "373", "MC" => "377", "MN" => "976", "ME" => "382", "MS" => "0", "MA" => "212", "MZ" => "258", "NA" => "264", "NR" => "674", "NP" => "977", "AN" => "599", "NC" => "687", "NI" => "505", "NE" => "227", "NU" => "683", "NF" => "0", "MP" => "0", "OM" => "968", "PK" => "92", "PW" => "680", "PS" => "0", "PA" => "507", "PG" => "675", "PY" => "595", "PE" => "51", "PH" => "63", "PN" => "0", "PR" => "0", "QA" => "974", "RE" => "262", "RU" => "7", "RW" => "250", "BL" => "0", "KN" => "0", "LC" => "0", "MF" => "0", "PM" => "508", "VC" => "0", "WS" => "685", "SM" => "378", "ST" => "239", "SA" => "966", "SN" => "221", "RS" => "381", "SC" => "248", "SL" => "232", "SI" => "386", "SB" => "677", "SO" => "252", "GS" => "0", "LK" => "94", "SD" => "249", "SR" => "597", "SJ" => "0", "SZ" => "268", "SY" => "963", "TW" => "886", "TJ" => "992", "TZ" => "255", "TH" => "66", "TK" => "690", "TO" => "676", "TT" => "0", "TN" => "216", "TR" => "90", "TM" => "993", "TC" => "0", "TV" => "688", "UG" => "256", "UA" => "380", "AE" => "971", "UY" => "598", "UZ" => "998", "VU" => "678", "VE" => "58", "VN" => "84", "VG" => "0", "VI" => "0", "WF" => "681", "EH" => "0", "YE" => "967", "ZM" => "260", "ZW" => "263", "AL" => "355", "AF" => "93", "AQ" => "0", "BA" => "387", "BV" => "0", "IO" => "0", "BG" => "359", "KY" => "0", "CX" => "0", "CC" => "0", "CK" => "682", "GF" => "594", "PF" => "689", "TF" => "0", "AX" => "0");
    static public $countryPrefix = array("cs" => "420", "sk" => "421", "es-ar" => "54", "de-at" => "43", "de" => "49", "de-li" => "423", "de-lu" => "352", "de-ch" => "41", "fr-be" => "32", "fr-ca" => "1", "fr" => "33", "fr-lu" => "352", "fr-mc" => "377", "fr-ch" => "41", "nl-be" => "32", "nl" => "31", "es-bo" => "591", "es-cl" => "56", "es-co" => "57", "es-cr" => "506", "es-do" => "1", "es-ec" => "593", "es-sv" => "503", "es-gt" => "502", "es-hn" => "504", "es" => "34", "es-mx" => "52", "es-ni" => "505", "es-pa" => "507", "es-py" => "595", "es-pe" => "51", "es-pr" => "1", "es-us" => "1", "es-uy" => "598", "es-ve" => "58", "sq" => "355", "ar-dz" => "213", "ar-bh" => "973", "ar-eg" => "20", "ar-iq" => "964", "ar-jo" => "962", "ar-kw" => "965", "ar-lb" => "961", "ar-ly" => "218", "ar-ma" => "212", "ar-om" => "968", "ar-qa" => "974", "ar-sa" => "966", "ar-sy" => "963", "ar-tn" => "216", "ar-ae" => "971", "ar-ye" => "967", "hy" => "374", "eu" => "34", "be" => "375", "bg" => "359", "ca" => "34", "zh-cn" => "86", "zh-hk" => "852", "zh-mo" => "853", "zh-sg" => "65", "zh-tw" => "886", "zh" => "86", "hr" => "385", "da" => "45", "en-au" => "61", "en-bz" => "501", "en-ca" => "1", "en-ie" => "353", "en-jm" => "1", "en-nz" => "64", "en-ph" => "63", "en-za" => "27", "en-tt" => "1", "en-gb" => "44", "en-us" => "1", "en-zw" => "263", "en" => "1", "et" => "372", "fo" => "298", "fi" => "358", "mk" => "389", "ka" => "995", "el" => "30", "he" => "972", "hi" => "91", "hu" => "36", "is" => "354", "id" => "62", "it" => "39", "it-ch" => "41", "ja" => "81", "kn" => "91", "kk" => "7", "ko" => "82", "kz" => "996", "lv" => "371", "lt" => "370", "ms" => "60", "mt" => "356", "mn" => "976", "ne" => "91", "nb-no" => "47", "no" => "47", "nn-no" => "47", "pl" => "48", "pt-br" => "55", "pt" => "351", "pa" => "91", "ro-md" => "373", "ro" => "40", "ru-md" => "373", "ru" => "7", "sa" => "91", "sr" => "381", "sr" => "381", "ls" => "386", "sb" => "49", "sw" => "255", "sv-fi" => "358", "sv" => "46", "syr" => "963", "ta" => "94", "th" => "66", "ts" => "27", "tn" => "267", "tr" => "90", "uk" => "380", "ur" => "92", "uz" => "998", "vi" => "84", "xh" => "27", "yi" => "972", "zu" => "27", "as" => "91", "az" => "994", "bn" => "880", "div" => "960", "gd" => "44", "gu" => "91", "ml" => "91", "mr" => "91", "mr" => "91", "tt" => "7", "te" => "91", "km" => "855", "fa" => "98", "sg" => "236", "ln" => "242", "mi" => "64", "aa" => "251", "am" => "251", "om" => "251", "ti" => "291", "fj" => "679", "tw" => "233", "kl" => "299", "ch" => "1", "ki" => "254", "lo" => "856", "st" => "266", "mg" => "261", "ny" => "265", "my" => "95", "na" => "674", "ne" => "977", "hz" => "264", "ng" => "264", "ha" => "227", "yo" => "234", "ho" => "675", "rw" => "250", "sm" => "685", "wo" => "221", "so" => "252", "ss" => "268", "to" => "676", "bi" => "678", "ab" => "995", "ae" => "98", "af" => "27", "ar" => "20", "ay" => "591", "ba" => "7", "bh" => "91", "bo" => "86", "br" => "33", "bs" => "387", "ce" => "7", "co" => "33", "cu" => "359", "cv" => "7", "cy" => "44", "dz" => "975", "fy" => "31", "ga" => "353", "gl" => "34", "gn" => "595", "gv" => "44", "ik" => "1", "iu" => "1", "iw" => "972", "jw" => "62", "kj" => "244", "ks" => "91", "ku" => "90", "kv" => "7", "kw" => "44", "ky" => "996", "la" => "39", "lb" => "352", "nb" => "47", "nd" => "27", "nn" => "47", "nr" => "27", "nv" => "1", "oc" => "33", "or" => "91", "os" => "7", "pi" => "91", "ps" => "92", "qu" => "51", "rm" => "41", "rn" => "250", "sc" => "39", "sd" => "91", "se" => "46", "si" => "94", "sl" => "386", "sh" => "263", "su" => "62", "tg" => "992", "tk" => "993", "tl" => "63", "ug" => "86", "za" => "86");
    static public $countryNames = array("cs" => "Czech Republic", "sk" => "Slovakia", "es-ar" => "Argentina", "de-at" => "Austria", "de" => "Germany", "de-li" => "Liechtenstein", "de-lu" => "Luxembourg", "de-ch" => "Switzerland", "fr-be" => "Belgium", "fr-ca" => "Canada", "fr" => "France", "fr-lu" => "Luxembourg", "fr-mc" => "Monaco", "fr-ch" => "Switzerland", "nl-be" => "Belgium", "nl" => "Netherlands", "es-bo" => "Bolivia", "es-cl" => "Chile", "es-co" => "Colombia", "es-cr" => "Costa Rica", "es-do" => "Dominican Republic", "es-ec" => "Ecuador", "es-sv" => "El Salvador", "es-gt" => "Guatemala", "es-hn" => "Honduras", "es" => "Spain", "es-mx" => "Mexico", "es-ni" => "Nicaragua", "es-pa" => "Panama", "es-py" => "Paraguay", "es-pe" => "Peru", "es-pr" => "Puerto Rico", "es-us" => "United States", "es-uy" => "Uruguay", "es-ve" => "Venezuela", "sq" => "Albania", "ar-dz" => "Algeria", "ar-bh" => "Bahrain", "ar-eg" => "Egypt", "ar-iq" => "Iraq", "ar-jo" => "Jordan", "ar-kw" => "Kuwait", "ar-lb" => "Lebanon", "ar-ly" => "Libyan Arab Jamahiriya", "ar-ma" => "Morocco", "ar-om" => "Oman", "ar-qa" => "Qatar", "ar-sa" => "Saudi Arabia", "ar-sy" => "Syria", "ar-tn" => "Tunisia", "ar-ae" => "United Arab Emirates", "ar-ye" => "Yemen", "hy" => "Armenia", "eu" => "Spain", "be" => "Belarus", "bg" => "Bulgaria", "ca" => "Spain", "zh-cn" => "China", "zh-hk" => "Hong Kong", "zh-mo" => "Macau", "zh-sg" => "Singapore", "zh-tw" => "Taiwan", "zh" => "China", "hr" => "Croatia", "da" => "Denmark", "en-au" => "Australia", "en-bz" => "Belize", "en-ca" => "Canada", "en-ie" => "Ireland", "en-jm" => "Jamaica", "en-nz" => "New Zealand", "en-ph" => "Philippines", "en-za" => "South Africa", "en-tt" => "Trinidad and Tobago", "en-gb" => "United Kingdom", "en-us" => "United States", "en-zw" => "Zimbabwe", "en" => "United States", "et" => "Estonia", "fo" => "Faroe Islands", "fi" => "Finland", "mk" => "Macedonia", "ka" => "Georgia", "el" => "Greece", "he" => "Israel", "hi" => "India", "hu" => "Hungary", "is" => "Iceland", "id" => "Indonesia", "it" => "Italy", "it-ch" => "Switzerland", "ja" => "Japan", "kn" => "India", "kk" => "Kazakhstan", "ko" => "Korea", "kz" => "Kyrgyzstan", "lv" => "Latvia", "lt" => "Lithuania", "ms" => "Malaysia", "mt" => "Malta", "mn" => "Mongolia", "ne" => "India", "nb-no" => "Norway", "no" => "Norway", "nn-no" => "Norway", "pl" => "Poland", "pt-br" => "Brazil", "pt" => "Brazil", "pa" => "India", "ro-md" => "Moldova", "ro" => "Romania", "ru-md" => "Moldova", "ru" => "Russian Federation", "sa" => "India", "sr" => "Serbia", "sr" => "Serbia", "ls" => "Slovenia", "sb" => "Germany", "sw" => "Tanzania", "sv-fi" => "Finland", "sv" => "Sweden", "syr" => "Syrian Arab Republic", "ta" => "Sri Lanka", "th" => "Thailand", "ts" => "South Africa", "tn" => "Botswana", "tr" => "Turkey", "uk" => "Ukraine", "ur" => "India", "uz" => "Uzbekistan", "vi" => "Vietnam", "xh" => "South Africa", "yi" => "Israel", "zu" => "South Africa", "as" => "India", "az" => "Iran", "bn" => "Bangladesh", "div" => "Maldives", "gd" => "United Kingdom", "gu" => "India", "ml" => "India", "mr" => "India", "mr" => "India", "tt" => "Russian Federation", "te" => "India", "km" => "Cambodia", "fa" => "Iran", "sg" => "Central African Republic", "ln" => "Congo", "mi" => "New Zealand", "aa" => "Ethiopia", "am" => "Ethiopia", "om" => "Ethiopia", "ti" => "Eritrea", "fj" => "Fiji", "tw" => "Ghana", "kl" => "Greenland", "ch" => "United States", "ki" => "Kenya", "lo" => "Lao Peoples Democratic Republic", "st" => "Lesotho", "mg" => "Madagascar", "ny" => "Malawi", "my" => "Myanmar", "na" => "Nauru", "ne" => "Nepal", "hz" => "Namibia", "ng" => "Namibia", "ha" => "Niger", "yo" => "Nigeria", "ho" => "Papua New Guinea", "rw" => "Rwanda", "sm" => "Samoa", "wo" => "Senegal", "so" => "Somalia", "ss" => "Swaziland", "to" => "Tonga", "bi" => "Vanuatu", "ab" => "Georgia", "ae" => "Iran", "af" => "South Africa", "ar" => "Egypt", "ay" => "Bolivia", "ba" => "Russian Federation", "bh" => "India", "bo" => "China", "br" => "France", "bs" => "Bosnia and Herzegowina", "ce" => "Russian Federation", "co" => "France", "cu" => "Bulgaria", "cv" => "Russian Federation", "cy" => "United Kingdom", "dz" => "Bhutan", "fy" => "Netherlands", "ga" => "Ireland", "gl" => "Spain", "gn" => "Paraguay", "gv" => "United Kingdom", "ik" => "United States", "iu" => "Canada", "iw" => "Israel", "jw" => "Indonesia", "kj" => "Angola", "ks" => "India", "ku" => "Turkey", "kv" => "Russian Federation", "kw" => "United Kingdom", "ky" => "Kyrgyzstan", "la" => "Vatican City State", "lb" => "Luxembourg", "nb" => "Norway", "nd" => "South Africa", "nn" => "Norway", "nr" => "South Africa", "nv" => "United States", "oc" => "France", "or" => "India", "os" => "Russian Federation", "pi" => "India", "ps" => "Pakistan", "qu" => "Peru", "rm" => "Switzerland", "rn" => "Rwanda", "sc" => "Italy", "sd" => "India", "se" => "Sweden", "si" => "Sri Lanka", "sl" => "Slovenia", "sh" => "Zimbabwe", "su" => "Indonesia", "tg" => "Tajikistan", "tk" => "Turkmenistan", "tl" => "Philippines", "ug" => "China", "za" => "China",);
    static public $countries = array('93' => 'Afghanistan', '355' => 'Albania', '213' => 'Algeria', '376' => 'Andorra', '244' => 'Angola', '54' => 'Argentina', '374' => 'Armenia', '297' => 'Aruba', '61' => 'Australia', '43' => 'Austria', '994' => 'Azerbaijan', '973' => 'Bahrain', '880' => 'Bangladesh', '375' => 'Belarus', '32' => 'Belgium', '501' => 'Belize', '229' => 'Benin', '975' => 'Bhutan', '591' => 'Bolivia', '387' => 'Bosnia', '267' => 'Botswana', '55' => 'Brazil', '673' => 'Brunei', '359' => 'Bulgaria', '226' => 'Burkina Faso', '257' => 'Burundi', '855' => 'Cambodia', '237' => 'Cameroon', '238' => 'Cape Verde', '225' => 'CĂ´te d\'Ivoire', '236' => 'Central African R.', '57' => 'Colombia', '269' => 'Comoros', '242' => 'Congo', '243' => 'Congo Dem. R.', '682' => 'Cook Islands', '506' => 'Costa Rica', '385' => 'Croatia', '53' => 'Cuba', '357' => 'Cyprus', '420' => 'Czech Republic', '45' => 'Denmark', '253' => 'Djibouti', '593' => 'Ecuador', '20' => 'Egypt', '503' => 'El Salvador', '240' => 'Equatorial Guinea', '291' => 'Eritrea', '372' => 'Estonia', '251' => 'Ethiopia', '500' => 'Falkland Islands', '298' => 'Faroe Islands', '679' => 'Fiji', '358' => 'Finland', '33' => 'France', '241' => 'Gabon', '220' => 'Gambia', '995' => 'Georgia', '49' => 'Germany', '233' => 'Ghana', '350' => 'Gibraltar', '30' => 'Greece', '299' => 'Greenland', '590' => 'Guadeloupe', '594' => 'French Guiana', '502' => 'Guatemala', '224' => 'Guinea', '245' => 'Guinea-Bissau', '592' => 'Guyana', '509' => 'Haiti', '504' => 'Honduras', '852' => 'Hong Kong', '36' => 'Hungary', '235' => 'Chad', '56' => 'Chile', '86' => 'China', '354' => 'Iceland', '91' => 'India', '62' => 'Indonesia', '98' => 'Iran', '964' => 'Iraq', '353' => 'Ireland', '972' => 'Israel', '39' => 'Italy', '81' => 'Japan', '962' => 'Jordan', '254' => 'Kenya', '686' => 'Kiribati', '965' => 'Kuwait', '996' => 'Kyrgyzstan', '856' => 'Laos', '371' => 'Latvia', '961' => 'Lebanon', '266' => 'Lesotho', '231' => 'Liberia', '218' => 'Libya', '423' => 'Liechtenstein', '370' => 'Lithuania', '352' => 'Luxembourg', '853' => 'Macao', '389' => 'Macedonia', '261' => 'Madagascar', '265' => 'Malawi', '60' => 'Malaysia', '960' => 'Maldives', '223' => 'Mali', '356' => 'Malta', '596' => 'Martinique', '222' => 'Mauritania', '230' => 'Mauritius', '52' => 'Mexico', '373' => 'Moldova', '377' => 'Monaco', '976' => 'Mongolia', '382' => 'Montenegro', '212' => 'Morocco', '258' => 'Mozambique', '95' => 'Myanmar', '264' => 'Namibia', '674' => 'Nauru', '977' => 'Nepal', '31' => 'Netherlands', '599' => 'Netherlands Ant.', '687' => 'New Caledonia', '64' => 'New Zealand', '505' => 'Nicaragua', '227' => 'Niger', '234' => 'Nigeria', '47' => 'Norway', '968' => 'Oman', '92' => 'Pakistan', '680' => 'Palau', '507' => 'Panama', '675' => 'Papua N. Guinea', '595' => 'Paraguay', '51' => 'Peru', '63' => 'Philippines', '48' => 'Poland', '351' => 'Portugal', '974' => 'Qatar', '262' => 'RĂ©union', '40' => 'Romania', '7' => 'Russia, Kazakhstan', '250' => 'Rwanda', '508' => 'Saint Pierre a. M.', '239' => 'SĂŁo Tome a. P.', '685' => 'Samoa', '378' => 'San Marino', '966' => 'Saudi Arabia', '221' => 'Senegal', '381' => 'Serbia', '248' => 'Seychelles', '232' => 'Sierra Leone', '65' => 'Singapore', '421' => 'Slovak Republic', '386' => 'Slovenia', '677' => 'Solomon Islands', '252' => 'Somalia', '27' => 'South Africa', '82' => 'South Korea', '34' => 'Spain', '94' => 'Sri Lanka', '249' => 'Sudan', '597' => 'Suriname', '268' => 'Swaziland', '46' => 'Sweden', '41' => 'Switzerland', '963' => 'Syria', '886' => 'Taiwan', '992' => 'Tajikistan', '255' => 'Tanzania', '66' => 'Thailand', '228' => 'Togo', '676' => 'Tonga', '216' => 'Tunisia', '90' => 'Turkey', '993' => 'Turkmenistan', '688' => 'Tuvalu', '971' => 'UAE', '256' => 'Uganda', '380' => 'Ukraine', '44' => 'United Kingdom', '598' => 'Uruguay', '1' => 'USA, Canada', '998' => 'Uzbekistan', '678' => 'Vanuatu', '58' => 'Venezuela', '84' => 'Vietnam', '967' => 'Yemen', '260' => 'Zambia', '263' => 'Zimbabwe');
    static public $defaultVariables = array('order_id' => '000054', 'order_reference' => 'REF000054', 'order_payment' => v_smsprestashop_bankwire, 'order_total_paid' => '464', 'order_currency' => 'EUR', 'order_date' => '2012-06-28 08:33:49', 'order_date1' => '28.06.2012', 'order_date2' => '28/06/2012', 'order_date3' => '28-06-2012', 'order_date4' => '2012-06-28', 'order_date5' => '06.28.2012', 'order_date6' => '06/28/2012', 'order_date7' => '06-28-2012', 'order_time' => '08:33', 'order_time1' => '08:33:49', 'shop_domain' => 'shop.testdomain.com', 'shop_name' => 'TEST Shop', 'shop_email' => 'test@testshop.com', 'shop_phone' => '800123456', 'customer_id' => '123', 'customer_email' => 'test@test.com', 'customer_company' => v_smsprestashop_company, 'customer_lastname' => 'DOE', 'customer_firstname' => 'John', 'customer_address' => 'Street name 44', 'customer_postcode' => '12345', 'customer_city' => v_smsprestashop_city, 'customer_country' => v_smsprestashop_country, 'customer_state' => 'Florida', 'customer_phone' => '800123456', 'customer_mobile' => '900123456', 'customer_vat_number' => 'XX1234567', 'customer_invoice_company' => v_smsprestashop_company, 'customer_invoice_lastname' => 'DOE', 'customer_invoice_firstname' => 'John', 'customer_invoice_address' => 'Street name 44', 'customer_invoice_postcode' => '12345', 'customer_invoice_city' => v_smsprestashop_city, 'customer_invoice_country' => v_smsprestashop_country, 'customer_invoice_state' => 'Florida', 'customer_invoice_phone' => '800123456', 'customer_invoice_mobile' => '900123456', 'customer_invoice_vat_number' => 'XX1234567', 'customer_question' => 'Test text', 'product_name' => 'Apple iPad', 'product_id' => '331', 'product_quantity' => '54', 'product_quantity_reinjected' => '3', 'product_supplier' => 'Test supplier', 'product_supplier_id' => '33', 'product_ref' => 'REF123456', 'product_supplier_ref' => 'SREF123456', 'product_ean13' => 'ean13-1234567679', 'product_upc' => 'upc-1234567679', 'product_attribute_id' => '4', 'cart_id' => '64', 'carrier_id' => '2', 'carrier_name' => 'My carrier', 'employee_id' => '4', 'employee_email' => 'employee@testshop.com', 'orderSlip1' => '11/Test Product/1/1', 'orderSlip3' => '11/1/1', 'orderSlip5' => '11/REF123ABC/SUPPLREF123/EAN13xxxxxx/UPCxxxx/1/1', 'newOrder1' => '11/Test Product/1', 'newOrder3' => '11/1', 'newOrder5' => '11/REF123ABC/SUPPLREF123/EAN13xxxxxx/UPCxxxx/1', 'orderReturn1' => '11/Test Product/1/1', 'orderReturn3' => '11/1/1', 'orderReturn5' => '11/REF123ABC/SUPPLREF123/EAN13xxxxxx/UPCxxxx/1/1', 'order_shipping_number' => '123456789', 'customer_message' => 'test message', 'customer_message_short1' => 'test message - max 120 chars', 'customer_message_short2' => 'test message - max 100 chars', 'customer_message_short3' => 'test message - max 80 chars', 'total_paid' => '464', 'return_id' => '56', 'return_action_id' => '2', 'return_action' => 'refunded', 'return_date' => '2014-05-12', 'return_reason_id' => '1', 'return_reason' => 'Dead On Arrival', 'return_status_id' => '3', 'return_status' => 'Complete', 'order_products1' => '2x Apple iPhone iphone16G; 1x Samsung SIII samsungS3', 'order_products2' => '2x Apple iPhone; 1x Samsung SIII', 'order_products3' => '2x (12)Apple iPhone iphone16G; 1x (32)Samsung SIII samsungS3', 'product_model' => 'iPad16g');
    static public $hooks = array(
        "actionValidateOrder" => array(
            "name" => "actionValidateOrder",
            "info" => v_smsprestashop_sqlinfo1,
            "status" => 0,
            "owner" => 3,
            "group" => 1,
            "background" => "",
            "icon" => "",
            "template" => v_smsprestashop_sqltemplate1_oc,
            "template2" => v_smsprestashop_sqltemplate21_oc,
            "notice" => "<br /> {customer_id}, {customer_email}, {customer_company}, {customer_lastname}, {customer_firstname}, {customer_address}, {customer_postcode}, {customer_city}, {customer_country}, {customer_state}, {customer_phone}, {customer_mobile}, {customer_vat_number}, {customer_invoice_company}, {customer_invoice_lastname}, {customer_invoice_firstname}, {customer_invoice_address}, {customer_invoice_postcode}, {customer_invoice_city}, {customer_invoice_country}, {customer_invoice_state}, {customer_invoice_phone}, {customer_invoice_mobile}, {customer_invoice_vat_number}<br /><br />{shop_domain}, {shop_name}, {shop_email}, {shop_phone}<br /><br />{order_id}, {order_payment}, {order_total_paid}, {order_currency}, {order_date}, {order_date1}, {order_date2}, {order_date3}, {order_date4}, {order_date5}, {order_date6}, {order_date7}, {order_time}, {order_time1}, {order_shipping_number}, {order_reference}, {carrier_id}, {carrier_name}<br /><br />{order_products1}, {order_products2}, {order_products3}, {order_products4}, {order_products5}, {order_products6}, {order_products7}, {order_products8}, {order_products9}, {order_products10}, {order_products11}, {order_products12}<br /><br />{cart_id}, {customer_message}"
        ),
        "actionCustomerAccountAdd" => array(
            "name" => "actionCustomerAccountAdd",
            "info" => v_smsprestashop_sqlinfo2,
            "status" => 0,
            "owner" => 3,
            "group" => 2,
            "background" => "",
            "icon" => "",
            "template" => v_smsprestashop_sqltemplate2_oc,
            "template2" => v_smsprestashop_sqltemplate22_oc,
            "notice" => "<br /> {customer_id}, {customer_email}, {customer_lastname}, {customer_firstname}<br /><br />{shop_domain}, {shop_name}, {shop_email}, {shop_phone}"
        ),
        "actionProductOutOfStock" => array(
            "name" => "actionProductOutOfStock",
            "info" => v_smsprestashop_sqlinfo9,
            "status" => 0,
            "owner" => 1,
            "group" => 3,
            "background" => "",
            "icon" => "",
            "template" => v_smsprestashop_sqltemplate9_oc,
            "template2" => "",
            "notice" => "<br /> {shop_domain}, {shop_name}, {shop_email}, {shop_phone}<br /><br />\n{customer_id}, {customer_email}, {customer_lastname}, {customer_firstname}<br /><br />\n{product_id}, {product_quantity}, {product_name}, {product_ref}, {product_supplier_ref}, {product_ean13}, {product_upc}, {product_supplier_id}, {product_supplier}<br/><br/>{order_products1}, {order_products2}, {order_products3}, {order_products4}, {order_products5}, {order_products6}, {order_products7}, {order_products8}, {order_products9}, {order_products10}, {order_products11}, {order_products12}"
        ),
        "actionProductDelete" => array(
            "name" => "actionProductDelete",
            "info" => v_smsprestashop_sqlinfo7,
            "status" => 0,
            "owner" => 1,
            "group" => 3,
            "background" => "",
            "icon" => "",
            "template" => v_smsprestashop_sqltemplate7_oc,
            "template2" => "",
            "notice" => "<br /> {shop_domain}, {shop_name}, {shop_email}, {shop_phone}<br /><br />\n{product_id}, {product_name}, {product_ref}, {product_supplier_ref}, {product_ean13}, {product_upc}, {product_supplier_id}, {product_supplier}<br /><br />\n{employee_id}, {employee_email}"
        ),
        "contactformhook" => array(
            "name" => "contactformhook",
            "info" => v_contact_form,
            "status" => 0,
            "owner" => 1,
            "group" => 4,
            "background" => "",
            "icon" => "",
            "template" => "{customer_email} - {customer_message}",
            "template2" => "",
            "notice" => "<br /> {customer_email}, {customer_message}, {customer_message_short1}, {customer_message_short2}<br /><br />{contact_id}, {product_id}<br /><br />{shop_domain}, {shop_name}, {shop_email}, {shop_phone}<br /><br />\r\n{order_id}, {order_payment}, {order_total_paid}, {order_currency}, {order_date}, {order_date1}, {order_date2}, {order_date3}, {order_date4}, {order_date5}, {order_date6}, {order_date7}, {order_time}, {order_time1}, {order_shipping_number}, {order_reference}, {carrier_id}, {carrier_name}"
        ),
        "actionOrderSlipAdd" => array(
            "name" => "actionOrderSlipAdd",
            "info" => v_smsprestashop_sqlinfo4,
            "status" => 0,
            "owner" => 3,
            "group" => 1,
            "background" => "",
            "icon" => "",
            "template" => v_smsprestashop_sqltemplate4,
            "template2" => v_smsprestashop_sqltemplate24,
            "notice" => "<br /> {customer_id}, {customer_email}, {customer_company}, {customer_lastname}, {customer_firstname}, {customer_address}, {customer_postcode}, {customer_city}, {customer_country}, {customer_state}, {customer_phone}, {customer_mobile}, {customer_vat_number}, {customer_invoice_company}, {customer_invoice_lastname}, {customer_invoice_firstname}, {customer_invoice_address}, {customer_invoice_postcode}, {customer_invoice_city}, {customer_invoice_country}, {customer_invoice_state}, {customer_invoice_phone}, {customer_invoice_mobile}, {customer_invoice_vat_number}<br /><br />\n{shop_domain}, {shop_name}, {shop_email}, {shop_phone}<br /><br />{order_id}, {order_payment}, {order_total_paid}, {order_currency}, {order_date}, {order_date1}, {order_date2}, {order_date3}, {order_date4}, {order_date5}, {order_date6}, {order_date7}, {order_time}, {order_time1}, {order_shipping_number}, {order_reference}, {carrier_id}, {carrier_name}<br /><br />{orderSlip1}, {orderSlip2}, {orderSlip3}, {orderSlip4}, {orderSlip5}<br /><br />{order_products1}, {order_products2}, {order_products3}, {order_products4}, {order_products5}, {order_products6}, {order_products7}, {order_products8}, {order_products9}, {order_products10}, {order_products11}, {order_products12}<br/><br/>{employee_id}, {employee_email}"
        ),
        "actionPaymentConfirmation" => array(
            "name" => "actionPaymentConfirmation",
            "info" => v_smsprestashop_sqlinfo5,
            "status" => 0,
            "owner" => 3,
            "group" => 1,
            "background" => "",
            "icon" => "",
            "template" => v_smsprestashop_sqltemplate5,
            "template2" => v_smsprestashop_sqltemplate25,
            "notice" => "<br /> {customer_id}, {customer_email}, {customer_company}, {customer_lastname}, {customer_firstname}, {customer_address}, {customer_postcode}, {customer_city}, {customer_country}, {customer_state}, {customer_phone}, {customer_mobile}, {customer_vat_number}, {customer_invoice_company}, {customer_invoice_lastname}, {customer_invoice_firstname}, {customer_invoice_address}, {customer_invoice_postcode}, {customer_invoice_city}, {customer_invoice_country}, {customer_invoice_state}, {customer_invoice_phone}, {customer_invoice_mobile}, {customer_invoice_vat_number}<br /><br />\n{shop_domain}, {shop_name}, {shop_email}, {shop_phone}<br /><br />{order_id}, {order_payment}, {order_total_paid}, {order_currency}, {order_date}, {order_date1}, {order_date2}, {order_date3}, {order_date4}, {order_date5}, {order_date6}, {order_date7}, {order_time}, {order_time1}, {order_shipping_number}, {order_reference}, {carrier_id}, {carrier_name}<br /><br />{order_products1}, {order_products2}, {order_products3}, {order_products4}, {order_products5}, {order_products6}, {order_products7}, {order_products8}, {order_products9}, {order_products10}, {order_products11}, {order_products12}<br /><br />{employee_id}, {employee_email}"
        ),
        "actionAdminOrdersTrackingNumberUpdate" => array(
            "name" => "actionAdminOrdersTrackingNumberUpdate",
            "info" => v_smsprestashop_sqlinfo62,
            "status" => 0,
            "owner" => 3,
            "group" => 1,
            "background" => "",
            "icon" => "",
            "template" => v_smsprestashop_sqltemplate62,
            "template2" => v_smsprestashop_sqltemplate262,
            "notice" => "<br /> {customer_id}, {customer_email}, {customer_company}, {customer_lastname}, {customer_firstname}, {customer_address}, {customer_postcode}, {customer_city}, {customer_country}, {customer_state}, {customer_phone}, {customer_mobile}, {customer_vat_number}, {customer_invoice_company}, {customer_invoice_lastname}, {customer_invoice_firstname}, {customer_invoice_address}, {customer_invoice_postcode}, {customer_invoice_city}, {customer_invoice_country}, {customer_invoice_state}, {customer_invoice_phone}, {customer_invoice_mobile}, {customer_invoice_vat_number}<br /><br />{shop_domain}, {shop_name}, {shop_email}, {shop_phone}<br /><br />{order_id}, {order_payment}, {order_total_paid}, {order_currency}, {order_date}, {order_date1}, {order_date2}, {order_date3}, {order_date4}, {order_date5}, {order_date6}, {order_date7}, {order_time}, {order_time1}, {order_shipping_number}, {order_reference}, {carrier_id}, {carrier_name}<br /><br />{order_products1}, {order_products2}, {order_products3}, {order_products4}, {order_products5}, {order_products6}, {order_products7}, {order_products8}, {order_products9}, {order_products10}, {order_products11}, {order_products12}<br /><br />{employee_id}, {employee_email}"
        ),
        "actionUpdateQuantity" => array(
            "name" => "actionUpdateQuantity",
            "info" => v_smsprestashop_sqlinfo8,
            "status" => 0,
            "owner" => 1,
            "group" => 3,
            "background" => "",
            "icon" => "",
            "template" => v_smsprestashop_sqltemplate8,
            "template2" => "",
            "notice" => "<br /> {shop_domain}, {shop_name}, {shop_email}, {shop_phone}<br /><br />\n{customer_id}, {customer_email}, {customer_lastname}, {customer_firstname}<br /><br />\n{product_id}, {product_quantity}, {product_name}, {product_attribute_id}, {product_ref}, {product_supplier_ref}, {product_ean13}, {product_upc}, {product_supplier_id}, {product_supplier}<br /><br />\n{employee_id}, {employee_email}"
        ),
        "actionProductCancel" => array(
            "name" => "actionProductCancel",
            "info" => v_smsprestashop_sqlinfo10,
            "status" => 0,
            "owner" => 1,
            "group" => 3,
            "background" => "",
            "icon" => "",
            "template" => v_smsprestashop_sqltemplate10,
            "template2" => "",
            "notice" => "<br /> {customer_id}, {customer_email}, {customer_company}, {customer_lastname}, {customer_firstname}, {customer_address}, {customer_postcode}, {customer_city}, {customer_country}, {customer_state}, {customer_phone}, {customer_mobile}, {customer_vat_number}, {customer_invoice_company}, {customer_invoice_lastname}, {customer_invoice_firstname}, {customer_invoice_address}, {customer_invoice_postcode}, {customer_invoice_city}, {customer_invoice_country}, {customer_invoice_state}, {customer_invoice_phone}, {customer_invoice_mobile}, {customer_invoice_vat_number}<br /><br />\n{shop_domain}, {shop_name}, {shop_email}, {shop_phone}<br /><br />{order_id}, {order_payment}, {order_total_paid}, {order_currency}, {order_date}, {order_date1}, {order_date2}, {order_date3}, {order_date4}, {order_date5}, {order_date6}, {order_date7}, {order_time}, {order_time1}, {carrier_id}, {carrier_name}<br /><br />{product_id}, {product_quantity}, {product_quantity_reinjected}, {product_name}, {product_ref}, {product_supplier_ref}, {product_ean13}, {product_upc}, {product_supplier_id}, {product_supplier}<br /><br />{order_products1}, {order_products2}, {order_products3}, {order_products4}, {order_products5}, {order_products6}, {order_products7}, {order_products8}, {order_products9}, {order_products10}, {order_products11}, {order_products12}<br /><br />{employee_id}, {employee_email}"
        ),
        "actionOrderReturn" => array(
            "name" => "actionOrderReturn",
            "info" => v_smsprestashop_sqlinfo3,
            "status" => 0,
            "owner" => 3,
            "group" => 1,
            "background" => "",
            "icon" => "",
            "template" => v_smsprestashop_sqltemplate3,
            "template2" => v_smsprestashop_sqltemplate23,
            "notice" => "<br /> {customer_id}, {customer_email}, {customer_company}, {customer_lastname}, {customer_firstname}, {customer_address}, {customer_postcode}, {customer_city}, {customer_country}, {customer_state}, {customer_phone}, {customer_mobile}, {customer_vat_number}, {customer_invoice_company}, {customer_invoice_lastname}, {customer_invoice_firstname}, {customer_invoice_address}, {customer_invoice_postcode}, {customer_invoice_city}, {customer_invoice_country}, {customer_invoice_state}, {customer_invoice_phone}, {customer_invoice_mobile}, {customer_invoice_vat_number}<br /><br />{shop_domain}, {shop_name}, {shop_email}, {shop_phone}<br /><br />{order_id}, {order_payment}, {order_total_paid}, {order_currency}, {order_date}, {order_date1}, {order_date2}, {order_date3}, {order_date4}, {order_date5}, {order_date6}, {order_date7}, {order_time}, {order_time1}, {order_shipping_number}, {order_reference}, {carrier_id}, {carrier_name}<br /><br />{orderReturn1}, {orderReturn2}, {orderReturn3}, {orderReturn4}, {orderReturn5}<br /><br />{order_products1}, {order_products2}, {order_products3}, {order_products4}, {order_products5}, {order_products6}, {order_products7}, {order_products8}, {order_products9}, {order_products10}, {order_products11}, {order_products12}<br /><br />{customer_question}"
        )
    );

    static public function getVariables()
    {
        $array = self::$defaultVariables;
        
        $array["orderSlip"] = 'id:11, '.v_smsprestashop_name.': Test Product, '.v_smsprestashop_qty.':1, '.v_smsprestashop_qtyreinjected.':1'; 
        $array["orderSlip4"] = 'id:11, '.v_smsprestashop_qty.':1, '.v_smsprestashop_qtyreinjected.':1';
        $array["newOrder2"] =  'id: 11, '.v_smsprestashop_name.': Test Product, '.v_smsprestashop_qty.':1'; 
        $array["newOrder4"] =  'id: 11, '.v_smsprestashop_qty.':1';
        $array["orderReturn2"] =  'id: 11, '.v_smsprestashop_name.': Test Product, '.v_smsprestashop_qty.':1, '.v_smsprestashop_qtyreturned.': 1';
        $array["orderReturn4"] = 'id: 11, '.v_smsprestashop_qty.':1, '.v_smsprestashop_qtyreturned.': 1';
        
        $array["order_products1"] = '11/Test Product/1';
        $array["order_products2"] =  'id: 11, '.v_smsprestashop_name.': Test Product, '.v_smsprestashop_qty.':1'; 
        $array["order_products3"] = '11/1';
        $array["order_products4"] =  'id: 11, '.v_smsprestashop_qty.':1';
        $array["order_products5"] = '11/REF123ABC/SUPPLREF123/EAN13xxxxxx/UPCxxxx/1';
        $array["order_products6"] = 'Test Product, Qty: 1';
        
        $array["order_products7"] = '11/Test Product/1\n12/Test Product2/2';
        $array["order_products8"] =  'id: 11, '.v_smsprestashop_name.': Test Product, '.v_smsprestashop_qty.':1\n'.'id: 12, '.v_smsprestashop_name.': Test Product2, '.v_smsprestashop_qty.':2'; 
        $array["order_products9"] = '11/1\n12/2';
        $array["order_products10"] =  'id: 11, '.v_smsprestashop_qty.':1\nid: 12, '.v_smsprestashop_qty.':2';
        $array["order_products11"] = '11/REF123ABC/SUPPLREF123/EAN13xxxxxx/UPCxxxx/1\n12/REF123ABC/SUPPLREF123/EAN13xxxxxx/UPCxxxx/2';
        $array["order_products12"] = 'Test Product, Qty: 1\nTest Product2, Qty: 2';
               
        return $array;
    }
}
